#include-once
#include <FileConstants.au3>
#include <StringConstants.au3>
#include <AutoItConstants.au3>
#include <MsgBoxConstants.au3>
#include "ADO_CONSTANTS.au3"

#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w 7
#Tidy_Parameters=/sort_funcs /reel

#Region XMLWrapperEx.au3 - UDF Header
; #INDEX# =======================================================================================================================
; Title .........: XMLWrapperEx.au3
; AutoIt Version : 3.3.10.2++
; Language ......: English
; Description ...: Functions to use for reading and writing XML using msxml.
; Remarks .......: BETA Version
; Author(s) .....: mLipok, Eltorro, Weaponx, drlava, Lukasz Suleja, oblique, Mike Rerick, Tom Hohmann, guinness
; Version .......: "1.1.1.02" ; _XML_MiscProperty_UDFVersion()

#CS
	This UDF is created on the basis of:
	https://www.autoitscript.com/forum/topic/19848-xml-dom-wrapper-com/
	For this reason, I attach also the last known (to me) previous version ($_XMLUDFVER = "1.0.3.98"  _XMLDomWrapper_1.0.3.98_CN.au3 )
	For the same reason I continue to recognize the achievements of the work of my predecessors (they are still noted in each Function header).
	.
	.
	.
	. !!!!!!!!! This is BETA VERSION (all could be changed) !!!!!!!!!
	.
	.
	.
	WORK IN PROGRES INFORMATION:
	For now 2015-09-01 the descripion (Function Header) can not entirely correctly describe the function.
	TODO: in many places I used "TODO" as a keyword to find what should be done in future
	.
	I want to: PREVENT THIS:
	The unfortunate nature of both the scripts is that the func return results are strings or arrays instead of objects.
	.
	I want to: USE THIS CONCEPT:
	.   All function should use Refernce to the object as first Function parameter
	.   All function should return in most cases objects. There should be separate functions to Change Object collection to array
	.   All function should use COM Error Handler in local scope.
	.   All function should return @error which are defined in #Region XMLWrapperEx.au3 - @ERROR Enums
	.	All function should have the same naming convention
	.	All variables should have the same naming convention
	.	There should not to be any Global Variable - exception is $__g_oXMLDOM_EventsHandler
	.   It should be possible easy to use XML DOM Events
	.		https://msdn.microsoft.com/en-us/library/ms764697(v=vs.85).aspx
	.   It should be possible easy to Debug
	.	Ultimately, you should be able to do anything with your XML without having to use your own Error Handler.

	. MAIN MOTTO:  "Programs are meant to be read by humans, and only incidentally for computers to execute." - Donald Knuth



#CE

#CS
	; the previous version of UDF
	; Author ........: Stephen Podhajecki - Eltorro <gehossafats@netmdc.com>
	; Author ........: Weaponx
	; Modified ......: drlava, Lukasz Suleja, oblique, Mike Rerick, Tom Hohmann
	; Initial release Dec. 15, 2005

	;; There is also _MSXML.au3 at http://code.google.com/p/my-autoit/source/browse/#svn/trunk/Scripts/MSXML
	;; http://my-autoit.googlecode.com/files/_MSXML.au3
	;; which return the xml object instead of using a global var.
	;;
	;; Therefore using the one above, more than one xml file can be opened at a time.
	;; The unfortunate nature of both the scripts is that the func return results are strings or arrays instead of objects.


	The following description is intended only to show the extent of the changes that have taken place in relation to the source version of the UDF
	PLEASE TREAT THIS AS QUITE NEW UDF
	2015/09/02
	"1.1.1.01"


	. Global Variable renaming: $fXMLAUTOSAVE > $g__bXMLAUTOSAVE - mLipok
	. Global Variable renaming: $fADDFORMATTING > $g__bADDFORMATTING - mLipok
	. Global Variable renaming: $DOMVERSION > $g__iDOMVERSION - mLipok
	. Global Variable renaming: $_XMLUDFVER > $g__sXML_UDF_VERSION - mLipok

	. Local Variable renaming: $fDebug > $bDebug - mLipok
	. Local Variable renaming: $strNameSpc > $sNameSpace - mLipok
	. Local Variable renaming: $strXPath > $sXPath - mLipok

	. added EventHandler for __XML_DOM_EVENT_onreadystatechange - mLipok
	. added EventHandler for __XML_DOM_EVENT_ondataavailable - mLipok
	. added EventHandler for __XML_DOM_EVENT_ontransformnode - mLipok

	. _XML_Misc* functions renamed and extended - mLipok
	. #Region -- grouping functions - mLipok
	. New Enums - Stream Object - ReadText Method - StreamReadEnum - mLipok
	. New Enums - readyState Property (DOMDocument) - mLipok
	. New Function: _XML_ComErrorHandler_UserFunction - mLipok
	. added ADO_CONSTANTS.au3 - mLipok


	??
	. __XML_ComErrorHandler_InternalFunction() CleanUp - mLipok
	. __XML_ComErrorHandler_InternalFunction() new parameters - mLipok

	SCRIPT BREAKING CHANGES
	. all function renamed from _XMLSomeName to _XML_SomeName ; TODO not yet all, but that is the plan - mLipok
	. Function _DebugWrite renamed to __XML_Misc_ConsoleNotifier - mLipok
	. Function _XSL_GetDefaultStyleSheet renamed to __XSL_GetDefaultStyleSheet - mLipok
	. Function _XMLGetDomVersion renamed to _XML_Misc_GetDomVersion - mLipok
	. Func _SetDebug renamed to _XML_MiscProperty_NotifyToConsole - mLipok
	. Removed $fDEBUGGING as is now used inside _XML_MiscProperty_NotifyToConsole - mLipok
	. Removed $bXMLAUTOSAVE as is now used inside _XML_MiscProperty_AutoSave - mLipok
	. Removed $bADDFORMATTING as is now used inside _XML_MiscProperty_AutoFormat - mLipok
	. Removed $g__iDOMVERSION as is now used inside __XML_MiscProperty_DomVersion - mLipok
	. standardarization for using Return Value for failure: return 0 and set @error to none 0 - mLipok
	. _XML_Load on success return $oXmlDoc instead 1 - mLipok
	. _XML_LoadXML on success return $oXmlDoc instead 1 - mLipok
	. $oXmlDoc is no longer global variable (must be passed to function as ByRef) - mLipok
	. removed many variable declaration used even for variable iteration "For $i to 10" - mLipok

	2015/09/04
	"1.1.1.02"
	. event handler renamed to $__g_oXMLDOM_EventsHandler - mLipok
	. added $XMLWRAPPER_ERROR_SAVEFILERO and checking in - mLipok
	. if variable is ObjectsCollection then variable name ends with sufix "Coll" - mLipok
	. variable used in loops are named with sufix "_idx" like this For $iAttribute_idx = 0 To $oAttributesColl.length - 1 - mLipok
	. variable used in loops are named with sufix "Enum" like this For $oNodeEnum in $oNodesColl - mLipok
	. Local Variable renaming: $strQuery > $sQuery - mLipok - thanks to guinness
	. Local Variable renaming: $sComment > $sComment - mLipok - thanks to guinness
	. Function renamed fixed typo in function name _XML_CreateAttributeute => _XML_CreateAttribute - mLipok - thanks to guinness
	. Function renamed _XML_Misc_NodesList_GetNames >> _XML_Array_GetNodesNamesFromCollection - mLipok
	. Global Enum renamed from   $g__eXML_.....    to    $__g_eXML_..... - mLipok
	. Function renamed _XML_ArrayAdd >> _XML_Array_AddName - mLipok
	. Function renamed _XML_Misc_NodesColl_GetNamesToArray >> _XML_Array_GetNodesNamesFromCollection - mLipok
	. Function renamed _XML_DeleteNode_XML_DeleteNode >> _XML_removeAll - mLipok
	. Function renamed _XML_FileOpen >> _XML_Load - mLipok
	. new Function _XML_Array_GetNodeList() - mLipok
	. UDF FileName: _XMLWrapperEx.au3 >> XMLWrapperEx.au3 - mLipok
	. !!! EXAMPLES FILE:    XMLWrapperEx__Examples.au3 - mLipok

	2015/09/06
	"1.1.1.03"
	. Renamed Function: _XMLCreateChildWAttr >> _XML_CreateChildWAttr - mLipok
	. Renamed ENUMs:  $__g_eXML_ERROR... >> $XMLWRAPPER_ERROR... - mLipok - Thanks to guinness
	. Renamed ENUMs:  $__g_eXML_RESULT... >> $XMLWRAPPER_RESULT... - mLipok - Thanks to guinness
	. Renamed CONST:  $XMLDOM_DOCUMENT_READYSTATE_... >> $XMLWRAPPER_DOCUMENT_READYSTATE_... - mLipok - Thanks to guinness
	. Renamed Variable : $oXML_Document >> $oXmlDoc  - for shortness, and compliance with examples of MSDN - mLipok
	. New Example: _Example_2__XML_CreateChildWAttr - mLipok
	. New Example: _Example_3__XML_Misc_ErrorDecription - mLipok
	. New Example: _Example_MSDN_1__setAttributeNode - mLipok
	. New Function: _XML_Misc_Viewer - mLipok
	. New: Function: _XML_Misc_ErrorParser() -- added as a replacment for using: _XML_Misc_ErrorDecription() - mLipok
	. NEW: @ERROR result: $XMLWRAPPER_ERROR_ARRAY - mLipok
	. NEW: @ERROR result: $XMLWRAPPER_ERROR_NODECREATEAPPEND - mLipok
	. Removed: all old _XML_Misc_ErrorDecription() - mLipok
	. Removed: _XML_Misc_ErrorDecription_Reset()- mLipok
	. Removed: all $sXML_error - mLipok
	. Removed: _XML_Error_Reason - mLipok
	. COMPLETED: @error checking for   .selectNodes  methods: @error is set to: $XMLWRAPPER_ERROR_XPATH - mLipok
	. COMPLETED: _XML_CreateChildWAttr - mLipok
	. COMPLETED: Standardarization for using Return Value @error codes returned from function --> ENUMERATED CONSTATNS - mLipok
	. 		Now all functions  Return like the following examples:
	.				Return SetError($XMLWRAPPER_ERROR_.........
	.					or in this way:
	.				If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)


	2015/09/07
	"1.1.1.04"
	. Renamed: $iXMLWrapper_Error_number >> $iXMLWrapper_Error - mLipok
	. Removed: almost all MsgBox() - leaves only in __XML_Misc_MsgBoxNotifier() - mLipok
	. Changed: in Examples : Global $oErrorHandler >> Local $oErrorHandler - mLipok
	. Renamed _XML_Array_GetNodeList >> _XML_Array_GetNodesProperties - mLipok
	. Removed: _XML_Array_GetNodesFromCollection as this was duplicate for _XML_Array_GetNodesProperties - mLipok
	. NEW: $eNodeList_attributes in function _XML_Array_GetNodesProperties - now also display all atributes - mLipok
	. Renamed: _XML_MiscProperty_DomVersion >> __XML_MiscProperty_DomVersion - as this should be internal - as you can use _XML_Misc_GetDomVersion() - mLipok
	. Renamed: _XML_ComErrorHandler_MainFunction >> __XML_ComErrorHandler_MainFunction - as this should be internal - mLipok
	. Renamed: _XML_ErrorParser >> _XML_ErrorParser_GetDescription - mLipok
	. Removed: _XML_Misc_ErrorParser - will be in Examples - mLipok
	. Changed: Return value behavior - mLipok
	.	From:
	.		SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $oXmlDoc.parseError.reason)
	.		SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
	. Changed: _XML_Load and _XML_LoadXML require $oXmlDoc as first parameter, you must use _XML_CreateObject() as only in this way it is possible to use _XML_ErrorParser_GetDescription() - mLipok
	.		All examples changed to show how to use "new" _XML_Load and _XML_LoadXML
	. NEW: ENUMs: $XMLWRAPPER_ERROR_EMPTYCOLLECTION - mLipok
	. NEW: ENUMs: $XMLWRAPPER_ERROR_NONODESMATCH - mLipok
	. Changed: MAGIC NUMBERS: for StringStripWS in _XML_DeleteNode() - mLipok
	. COMPLETED: _XML_NodeExists - mLipok
	. COMPLETED: Refactroing all functions with "selectNodes" Method now have checking: If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then ... SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION ..... - mLipok
	. COMPLETED: Refactroing all functions with "selectSingleNode" Method now have checking: If $oNode_Selected = Null Then .. SetError($XMLWRAPPER_ERROR_NONODESMATCH ..... - mLipok


	2015/09/09
	"1.1.1.05"
	. NEW: ENUMs: $XMLWRAPPER_ERROR_PARSE_XSL - mLipok
	. NEW: ENUMs: $XMLWRAPPER_ERROR_NOATTRMATCH - mLipok
	. COMPLETED: Function: _XML_RemoveAttribute() - mLipok
	. NEW EXAMPLE: _Example_4__XML_RemoveAttribute() - mLipok
	. Renamed: _XMLReplaceChild >> _XML_ReplaceChild - mLipok
	. COMPLETED: _XML_ReplaceChild - mLipok
	. NEW EXAMPLE: _Example_5__XML_ReplaceChild() - mLipok
	. NEW: ENUMs: $XMLWRAPPER_ERROR_NOCHILDMATCH - mLipok
	. NEW EXAMPLE: _Example_5__XML_ReplaceChild() - mLipok
	. NEW EXAMPLE: _Example_6__XML_GetChildNodes() - mLipok
	. COMPLETED: _XML_GetChildNodes() - mLipok
	. COMPLETED: _XML_GetAllAttribIndex() - mLipok
	. NEW Function: _XML_Array_GetAttributesProperties() - mLipok
	. NEW EXAMPLE: _Example_7__XML_GetAllAttribIndex() - mLipok
	. ADDED: many IsObj() >> https://www.autoitscript.com/forum/topic/177176-why-isobj-0-and-vargettype-object/
	.
	.
	.
	. @WIP..........

	@LAST - this keyword is usefull for quick jumping here
	@DONE - this keyword is usefull for bookmark finished/completed functions
	@WIP  - this keyword is usefull for finding function which I actualy working on .
	@OLD  - this keyword is usefull for finding code which will be removed, temporary stay for checking

	#CS

	#CE

	WORK IN PROGRESS
	.
	.


	TODO LIST:
	. Description, Function Header CleanUp (are still old)
	. browse entire UDF for TODO "Keyword"
	. Return SetError($XMLWRAPPER_ERROR_GENERAL... should be used only once per function
	. Return SetError($XMLWRAPPER_ERROR_GENERAL... should be always as the last Error returned from function
	. $XMLWRAPPER_ERROR_.... should be reordered it will be SCRIPT BREAKING CHANGES: only if used MAGIC NUMBERS for @error checking

#CE
#EndRegion XMLWrapperEx.au3 - UDF Header

; ===============================================================================================================================
; XML DOM Wrapper functions

; #VARIABLES# ===================================================================================================================

#Region XMLWrapperEx.au3 - Result Enums
Global Enum _
		$XMLWRAPPER_RESULT_FAILURE, _
		$XMLWRAPPER_RESULT_SUCCESS, _
		$XMLWRAPPER_RESULT_COUNTER
#EndRegion XMLWrapperEx.au3 - Result Enums

#Region XMLWrapperEx.au3 - @ERROR Enums
Global Enum _
		$XMLWRAPPER_ERROR_OK, _ ; All is ok
		$XMLWRAPPER_ERROR_GENERAL, _ ; The error which is not specifically defined.
		$XMLWRAPPER_ERROR_ISNOTOBJECT, _ ; No object passed to function.
		$XMLWRAPPER_ERROR_ISNOTVALIDOBJECT, _ ; Invalid object passed to function.
		$XMLWRAPPER_ERROR_PARSE, _ ; Error with Parsing objects use _XML_ErrorParser_GetDescription() for Get details
		$XMLWRAPPER_ERROR_LOAD, _ ; Error opening specified file.
		$XMLWRAPPER_ERROR_SAVE, _ ; Error saving file.
		$XMLWRAPPER_ERROR_SAVEFILERO, _ ; Destination file is Read Only.
		$XMLWRAPPER_ERROR_XPATH, _ ; XPath syntax error - you should check also COM Error Handler.
		$XMLWRAPPER_ERROR_DOMVERSION, _ ; Check @extended for required DOM Version
		$XMLWRAPPER_ERROR_PARAMETER, _ ; Wrong parameter passed to function.
		$XMLWRAPPER_ERROR_ARRAY, _ ; Wrong array parameter passed to function. Check array dimension and conent.
		$XMLWRAPPER_ERROR_NODECREATEAPPEND, _ ; Can not create or append Node
		$XMLWRAPPER_ERROR_EMPTYCOLLECTION, _ ; Collections of objects was empty
		$XMLWRAPPER_ERROR_NONODESMATCH, _ ;  No nodes match the XPath expression
		$XMLWRAPPER_ERROR_PARSE_XSL, _ ; Error with Parsing XSL objects use _XML_ErrorParser_GetDescription() for Get details
		$XMLWRAPPER_ERROR_NOATTRMATCH, _ ; There is no such attribute in selected node.
		$XMLWRAPPER_ERROR_NOCHILDMATCH, _ ; There is no Child in nodes matched by XPath expression.
		$XMLWRAPPER_ERROR_COUNTER
#EndRegion XMLWrapperEx.au3 - @ERROR Enums

#Region XMLWrapperEx.au3 - XML DOM Enumerated Constants
;~ https://msdn.microsoft.com/en-us/library/ms766473(v=vs.85).aspx
Global Const $NODE_ELEMENT = 1
Global Const $NODE_ATTRIBUTE = 2
Global Const $NODE_TEXT = 3
Global Const $NODE_CDATA_SECTION = 4
Global Const $NODE_ENTITY_REFERENCE = 5
Global Const $NODE_ENTITY = 6
Global Const $NODE_PROCESSING_INSTRUCTION = 7
Global Const $NODE_COMMENT = 8
Global Const $NODE_DOCUMENT = 9
Global Const $NODE_DOCUMENT_TYPE = 10
Global Const $NODE_DOCUMENT_FRAGMENT = 11
Global Const $NODE_NOTATION = 12
#EndRegion XMLWrapperEx.au3 - XML DOM Enumerated Constants

#Region XMLWrapperEx.au3 - readyState Property (DOMDocument)
;~ https://msdn.microsoft.com/en-us/library/ms753702(v=vs.85).aspx
Global Const $XMLWRAPPER_DOCUMENT_READYSTATE_LOADING = 1
Global Const $XMLWRAPPER_DOCUMENT_READYSTATE_LOADED = 2
Global Const $XMLWRAPPER_DOCUMENT_READYSTATE_INTERACTIVE = 3
Global Const $XMLWRAPPER_DOCUMENT_READYSTATE_COMPLETED = 4
#EndRegion XMLWrapperEx.au3 - readyState Property (DOMDocument)

Global $__g_oXMLDOM_EventsHandler = Null

; #INTERNAL_USE_ONLY#==========================================================
; Name ..........: __AddFormat
; Description ...:
; Syntax.........: __AddFormat($oXmlDoc[, $oParent = ""])
; Parameters ....: $oXmlDoc	      - XML Document to format
;                  $oParent     - Optional node to add formatting to
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......: Just break up the tags, no indenting is done here.
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func __AddFormat(ByRef $oXmlDoc, $oParent = "")
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	If _XML_MiscProperty_AutoFormat() Then
		Local $oNode_Format = $oXmlDoc.createTextNode(@CR)
		If IsObj($oParent) Then
			$oParent.appendChild($oNode_Format)
			If @error Then Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

		Else
			$oXmlDoc.documentElement.appendChild($oNode_Format)
			If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

		EndIf
	EndIf
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

EndFunc   ;==>__AddFormat

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_CreateAttribute
; Description ...: Adds an XML Attribute to specified node.
; Syntax ........: _XML_CreateAttribute(Byref $oXmlDoc, $sXPath, $sAttribute_Name[, $sAttribute_Value = ""])
; Parameters ....: $oXmlDoc             - [in/out] an object.
;                  $sXPath              - a string value. The XML tree path from root node (root/child/child..)
;                  $sAttribute_Name     - a string value. The attribute Name to create.
;                  $sAttribute_Value    - [optional] a string value. Default is "". The value to give the attribute.
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: Yes
; ===============================================================================================================================
Func _XML_CreateAttribute(ByRef $oXmlDoc, $sXPath, $sAttribute_Name, $sAttribute_Value = "")
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNode_Selected = $oXmlDoc.selectSingleNode($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf $oNode_Selected = Null Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf Not IsObj($oNode_Selected) Then ; https://www.autoitscript.com/forum/topic/177176-why-isobj-0-and-vargettype-object/
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	; create attribute and setting value
	Local $oAttribute = $oXmlDoc.createAttribute($sAttribute_Name);, $sNameSpace)
	$oAttribute.value = $sAttribute_Value

	; set attribute on node element
	$oNode_Selected.setAttributeNode($oAttribute)
	If $oXmlDoc.parseError.errorCode Then
		Return SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	; CleanUp
	$oAttribute = Null
	$oNode_Selected = Null

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)
EndFunc   ;==>_XML_CreateAttribute

; @DONE
; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_CreateChildWAttr
; Description ...: Create a child node(s) under the specified XPath NodeCollection with attributes.
; Syntax ........: _XML_CreateChildWAttr(Byref $oXmlDoc, $sXPath, $sNodeName[, $aAttributeList = Default[, $sNodeText = ""[,
;                  $sNameSpace = ""]]])
; Parameters ....: $oXmlDoc       - [in/out] an object.
;                  $sXPath              - a string value. The XML tree path from root node (root/child/child..)
;                  $sNodeName           - a string value. The nodeName
;                  $aAttributeList      - [optional] an array of XML Attributes. Column0=Name, Column1=Value
;                  $sNodeText               - [optional] a string value. Default is "".
;                  $sNameSpace          - [optional] a string value. Default is "".
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure        $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......: This function requires that each attribute name has a corresponding value.
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ===============================================================================================================================
Func _XML_CreateChildWAttr(ByRef $oXmlDoc, $sXPath, $sNodeName, $aAttributeList = Default, $sNodeText = "", $sNameSpace = "")
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local Enum _
			$eAttribute_Name, _
			$eAttribute_Value

	If Not (UBound($aAttributeList) > 0 And UBound($aAttributeList, 2) = 2) Then
		Return SetError($XMLWRAPPER_ERROR_ARRAY, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	For $iAttribute_idx = 0 To UBound($aAttributeList) - 1
		If _
				$aAttributeList[$iAttribute_idx][$eAttribute_Name] = '' _
				Or (Not IsString($aAttributeList[$iAttribute_idx][$eAttribute_Name])) _
				Or IsString($aAttributeList[$iAttribute_idx][$eAttribute_Value] = '') _
				Or (Not IsString($aAttributeList[$iAttribute_idx][$eAttribute_Value])) _
				Then
			Return SetError($XMLWRAPPER_ERROR_ARRAY, 0, $XMLWRAPPER_RESULT_FAILURE)
		EndIf
	Next

	Local $oNodesColl = $oXmlDoc.selectNodes($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Local $oChild_Temp = Null, $oAttribute_Temp = Null
	For $oNodeEnum In $oNodesColl
		#CS
			If Not ($oNodeEnum.hasChildNodes()) Then
			__AddFormat($oXmlDoc, $oNodeEnum)
			EndIf
		#CE
		If $sNameSpace = "" Then
			If Not ($oNodeEnum.namespaceURI = 0 Or $oNodeEnum.namespaceURI = "") Then $sNameSpace = $oNodeEnum.namespaceURI
		EndIf

		$oChild_Temp = $oXmlDoc.createNode($NODE_ELEMENT, $sNodeName, $sNameSpace)
		If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

		If $sNodeText <> "" Then $oChild_Temp.text = $sNodeText

		#CS @OLD
			$oAttribute_Temp = $oXmlDoc.createAttribute($aAttributes) ; $sNameSpace)
			$oChild_Temp.SetAttribute($aAttributes, $aValue)
		#CE

		For $iAttribute_idx = 0 To UBound($aAttributeList) - 1
			$oAttribute_Temp = $oXmlDoc.createAttribute($aAttributeList[$iAttribute_idx][$eAttribute_Name]);, $sNameSpace) ; TODO Check this comment
			If @error Then ExitLoop ; TODO Description ?

			$oAttribute_Temp.value = $aAttributeList[$iAttribute_idx][$eAttribute_Value]
			$oChild_Temp.setAttributeNode($oAttribute_Temp)

			#CS @OLD
				$oChild_Temp.SetAttribute($aAttributeList[$iAttribute_idx][$eAttribute_Name], $aAttributeList[$iAttribute_idx][$eAttribute_Value])
				If @error <> 0 Then
				Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)
				EndIf

			#CE
		Next

		; Appends a new child node as the last child of the node.
		$oNodeEnum.appendChild($oChild_Temp)
		If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

	Next

	#CS
		__AddFormat($oXmlDoc, $oNodeEnum)

	#CE
	$oChild_Temp = Null
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

EndFunc   ;==>_XML_CreateChildWAttr

; #FUNCTION# ===================================================================
; Name ..........: _XML_CreateComment
; Description ...: Create a COMMENT node at specified path.
; Syntax.........: _XML_CreateComment($sNode, $sComment)
; Parameters ....: $sNode       - The name of node to create.
;                  $sComment    - The comment to add the to the xml file.
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_CreateComment(ByRef $oXmlDoc, $sNode, $sComment)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNode_Selected = $oXmlDoc.selectSingleNode($sNode)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If $oNode_Selected = Null Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If Not ($oNode_Selected.hasChildNodes()) Then
		__AddFormat($oXmlDoc, $oNode_Selected)
	EndIf

	Local $oChild = $oXmlDoc.createComment($sComment)
	$oNode_Selected.insertBefore($oChild, $oNode_Selected.childNodes(0))
	__AddFormat($oXmlDoc)
	$oChild = ""
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS) ; TODO Check for what we need to return on success

EndFunc   ;==>_XML_CreateComment

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_CreateObject
; Description ...: Create Msxml2.DOMDocument Object
; Syntax ........: _XML_CreateObject([$iDOM_Version = -1])
; Parameters ....: $iDOM_Version                - [optional] an integer value. Default is -1.
; Return values .: Success             - 1 and set @error = 0
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
;                  |1 - Failed to create object with given MSXML version.
;                  |2 - MSXML not found. This object is required to use this program.
;                  |3 -
; Author ........:
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_CreateObject($iDOM_Version = -1)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	Local $oXmlDoc
	If $iDOM_Version <> -1 Then
		If $iDOM_Version > -1 And $iDOM_Version < 7 Then
			$oXmlDoc = ObjCreate("Msxml2.DOMDocument." & $iDOM_Version & ".0")
			If IsObj($oXmlDoc) Then
				__XML_MiscProperty_DomVersion($iDOM_Version)
			EndIf
		Else
			Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

		EndIf
	Else
		For $iDOM_Version_idx = 8 To 0 Step -1
			If FileExists(@SystemDir & "\msxml" & $iDOM_Version_idx & ".dll") Then
				$oXmlDoc = ObjCreate("Msxml2.DOMDocument." & $iDOM_Version_idx & ".0")
				If Not @error Then
					; If IsObj($oXmlDoc) Then
					__XML_MiscProperty_DomVersion($iDOM_Version_idx)
					ExitLoop
				EndIf
			EndIf
		Next
	EndIf

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $oXmlDoc)

EndFunc   ;==>_XML_CreateObject

; #FUNCTION# ===================================================================
; Name ..........: _XML_DeleteNode
; Description ...: Deletes XML Node based on XPath input from root node.
; Syntax.........: _XML_DeleteNode($sXPath)
; Parameters ....: $sXPath      - The XML tree path from root node (root/child/child..)
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
;                  |0 - No error
;                  |1 - Deletion error
;                  |2 - No object passed
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_DeleteNode(ByRef $oXmlDoc, $sXPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNodesColl = $oXmlDoc.selectNodes($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	For $oNodeEnum In $oNodesColl
		If $oNodeEnum.hasChildNodes Then
			For $oNodeEnum_Child In $oNodeEnum.childNodes
				If $oNodeEnum_Child.nodeType = $NODE_TEXT Then
					If StringStripWS($oNodeEnum_Child.text, $STR_STRIPLEADING + $STR_STRIPTRAILING + $STR_STRIPSPACES) = "" Then
						$oNodeEnum.removeChild($oNodeEnum_Child)
					EndIf
				EndIf
			Next
		EndIf
		$oNodeEnum.parentNode.removeChild($oNodeEnum)
	Next

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

EndFunc   ;==>_XML_DeleteNode

; @DONE
; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_GetAllAttribIndex
; Description ...: Get XML attributes collection from node element based on Xpath and specific index.
; Syntax ........: _XML_GetAllAttribIndex(Byref $oXmlDoc, $sXPath[, $iNodeIndex = 0])
; Parameters ....: $oXmlDoc             - [in/out] an object.
;                  $sXPath      		- XML tree path from root node (root/child/child..)
;                  $iNodeIndex          - [optional] an integer value. Default is 0. Specify which node in collection should be used.
; Return values .: Success        		- Attributes collection of object,
;                  Failure             	- $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: yes
; ===============================================================================================================================
Func _XML_GetAllAttribIndex(ByRef $oXmlDoc, $sXPath, $iNodeIndex = 0)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNodesColl = $oXmlDoc.selectNodes($sXPath )
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf


	Local $oAttributesColl = $oNodesColl.item($iNodeIndex).attributes
	If IsObj($oAttributesColl) Then
		Return SetError($XMLWRAPPER_ERROR_OK, 0, $oAttributesColl)
	ElseIf $oAttributesColl = Null Then
		Return SetError($XMLWRAPPER_ERROR_NOATTRMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf $oAttributesColl.length =0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	Else
		Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

EndFunc   ;==>_XML_GetAllAttribIndex

; @WIP
; #FUNCTION# ===================================================================
; Name ..........: _XML_GetAttrib
; Description ...: Get Attribute Value based on XPath and Attribute Name.
; Syntax.........: _XML_GetAttrib($sXPath, $sAttribute_Name[, $sQuery = ""])
; Parameters ....: $sXPath      - XML tree path from root node (root/child/child..)
;                  $sAttribute_Name     - The attribute node to read.
; Return values .: Success        - The attribute value.
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_GetAttrib(ByRef $oXmlDoc, $sXPath, $sAttribute_Name)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNode_Selected = $oXmlDoc.selectSingleNode($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf $oNode_Selected = Null Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf Not IsObj($oNode_Selected) Then ; https://www.autoitscript.com/forum/topic/177176-why-isobj-0-and-vargettype-object/
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	Else

		Local $oAttribute = $oNode_Selected.getAttributeNode($sAttribute_Name)
		If IsObj($oAttribute) Then
			Return SetError($XMLWRAPPER_ERROR_OK, 0, $oAttribute.value)
		ElseIf $oAttribute = Null Then
			Return SetError($XMLWRAPPER_ERROR_NOATTRMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
		Else
			Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)
		EndIf
	EndIf

EndFunc   ;==>_XML_GetAttrib

; @DONE
; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_GetChildNodes
; Description ...: Get XML child Node collection of node element based on XPath input from root node.
; Syntax ........: _XML_GetChildNodes(Byref $oXmlDoc, $sXPath)
; Parameters ....: $oXmlDoc             - [in/out] an object.
;                  $sXPath      		- XML tree path from root node (root/child/child..)
; Return values .: Success        		- Child Nodes collection, and @extended contains collection length (count)
;                  Failure             	- $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: yes
; ===============================================================================================================================
Func _XML_GetChildNodes(ByRef $oXmlDoc, $sXPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNode_Selected = $oXmlDoc.selectSingleNode($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf $oNode_Selected = Null Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf Not IsObj($oNode_Selected) Then ; https://www.autoitscript.com/forum/topic/177176-why-isobj-0-and-vargettype-object/
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If $oNode_Selected.hasChildNodes() Then
		Return SetError($XMLWRAPPER_ERROR_OK, $oNode_Selected.childNodes().length, $oNode_Selected.childNodes())
	Else
		Return SetError($XMLWRAPPER_ERROR_NOCHILDMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

EndFunc   ;==>_XML_GetChildNodes

; #FUNCTION# ===================================================================
; Name ..........: _XML_GetChildren
; Description ...: Selects XML child Node(s) of an element based on XPath input from root node and returns there text values.
; Syntax.........: _XML_GetChildren($sXPath)
; Parameters ....: $sXPath      - The XML tree path from root node (root/child/child..)
; Return values .: Success        - An array where:
;                  |$array[0][0] = Size of array
;                  |$array[1][0] = Name
;                  |$array[1][1] = Text
;                  |$array[1][2] = NameSpaceURI
;                  |...
;                  |$array[n][0] = Name
;                  |$array[n][1] = Text
;                  |$array[n][2] = NamespaceURI
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_GetChildren(ByRef $oXmlDoc, $sXPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNode_Selected = $oXmlDoc.selectSingleNode($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf $oNode_Selected = Null Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf Not IsObj($oNode_Selected) Then ; https://www.autoitscript.com/forum/topic/177176-why-isobj-0-and-vargettype-object/
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If $oNode_Selected.hasChildNodes() Then
		Local $iResponseDimSize = 0
		Local $aResponse[1][3] = [[$iResponseDimSize, '', '']]
		For $oNodeEnum_Child In $oNode_Selected.childNodes()
			If $oNodeEnum_Child.nodeType() = $NODE_ELEMENT And $oNodeEnum_Child.hasChildNodes() Then
				For $oNodeEnum_Descendant In $oNodeEnum_Child.childNodes()
					If $oNodeEnum_Descendant.nodeType() = $NODE_TEXT Then
						$iResponseDimSize = UBound($aResponse, 1)
						ReDim $aResponse[$iResponseDimSize + 1][3]
						$aResponse[$iResponseDimSize][0] = $oNodeEnum_Descendant.parentNode.baseName
						$aResponse[$iResponseDimSize][1] = $oNodeEnum_Descendant.text
						$aResponse[$iResponseDimSize][2] = $oNodeEnum_Descendant.NamespaceURI
						; TODO Check
						; _XML_Array_AddName($aResponse, $oNodeEnum_Child.baseName)
					EndIf
				Next
			EndIf
		Next

		$aResponse[0][0] = $iResponseDimSize
		Return SetError($XMLWRAPPER_ERROR_OK, $iResponseDimSize, $aResponse) ; TODO Description for @extended

	EndIf

	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

EndFunc   ;==>_XML_GetChildren

; #FUNCTION# ===================================================================
; Name ..........: _XML_GetChildText
; Description ...: Selects XML child Node(s) of an element based on XPath input from root node.
; Syntax.........: _XML_GetChildText($sXPath)
; Parameters ....: $sXPath      - The xml tree path from root node (root/child/child..)
; Return values .: Success        - An array of Nodes.
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_GetChildText(ByRef $oXmlDoc, $sXPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $aResponse[1] = [0]

	Local $oNode_Selected = $oXmlDoc.selectSingleNode($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf $oNode_Selected = Null Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf Not IsObj($oNode_Selected) Then ; https://www.autoitscript.com/forum/topic/177176-why-isobj-0-and-vargettype-object/
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If $oNode_Selected.hasChildNodes() Then
		; TODO Return Collection not ARRAY
		For $oNodeEnum_Child In $oNode_Selected.childNodes()
			If $oNodeEnum_Child.nodeType = $NODE_ELEMENT Then
				_XML_Array_AddName($aResponse, $oNodeEnum_Child.baseName)
			ElseIf $oNodeEnum_Child.nodeType = $NODE_TEXT Then
				_XML_Array_AddName($aResponse, $oNodeEnum_Child.text)
			EndIf
		Next

		$aResponse[0] = UBound($aResponse) - 1
		Return SetError($XMLWRAPPER_ERROR_OK, $aResponse[0], $aResponse) ; TODO Description for @extended

	EndIf

	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

EndFunc   ;==>_XML_GetChildText

; @WIP
; #FUNCTION# ===================================================================
; Name ..........: _XML_GetNodeCount
; Description ...: Get Node Count based on XPath input from root node, and for selected NodeType.
; Syntax.........: _XML_GetNodeCount($sXPath[, $sQuery = ""[, $iNodeType = $NODE_ELEMENT]])
; Parameters ....: $sXPath      - The XML tree path from root node (root/child/child..
;                  $sQuery        - A DOM compliant query string (not really necessary as it becomes part of the path
;                  $iNodeType     - The type of node to count. (element, attrib, comment etc.)
; Return values .: Success        - Number of nodes found (can be 0)
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki & DickB
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_GetNodeCount
; Description ...: Get Node Count based on XPath input from root node, and for selected NodeType.
; Syntax ........: _XML_GetNodeCount(Byref $oXmlDoc, $sXPath[, $sQuery = ""[, $iNodeType = $NODE_ELEMENT]])
; Parameters ....: $oXmlDoc             - [in/out] an object.
;                  $sXPath              - a string value. The XML tree path from root node (root/child/child..)
;                  $sQuery              - [optional] a string value. Default is "". A DOM compliant query string (not really necessary as it becomes part of the path
;                  $iNodeType           - [optional] an integer value. Default is $NODE_ELEMENT.
; Return values .: Success        - Number of nodes found (can be 0)
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki & DickB
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......; [yes/no]
; ===============================================================================================================================
Func _XML_GetNodeCount(ByRef $oXmlDoc, $sXPath, $sQuery = "", $iNodeType = $NODE_ELEMENT)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNodesColl = $oXmlDoc.selectNodes($sXPath & $sQuery)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Local $iNodeCount = 0
	For $oNodeEnum In $oNodesColl
		If $oNodeEnum.nodeType = $iNodeType Then $iNodeCount += 1
	Next

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $iNodeCount)

EndFunc   ;==>_XML_GetNodeCount

; #FUNCTION# ===================================================================
; Name ..........: _XML_GetNodesPath
; Description ...: Return a nodes full path based on XPath input from root node.
; Syntax.........: _XML_GetNodesPath($sXPath)
; Parameters ....: $sXPath      - The XML tree path from root node (root/child/child..)
; Return values .: Success        - An array of node names from root, count in [0] element.
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_GetNodesPath(ByRef $oXmlDoc, $sXPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	If _XML_Misc_GetDomVersion() < 4 Then
		Return SetError($XMLWRAPPER_ERROR_DOMVERSION, 4, $XMLWRAPPER_RESULT_FAILURE) ; TODO @extended Description

	EndIf

	Local $sNodePathTag ; TODO: Question $sNodePathTag what is for ?
	#forceref $sNodePathTag
	Local $aResponse[1], $sNodePath, $sNameSpace

	Local $oNodesColl = $oXmlDoc.selectNodes($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	; __XML_Misc_ConsoleNotifier("GetPath list length:" & $oNodesColl.length)
	Local $oParent, $oNodeEnum_Temp
	For $oNodeEnum In $oNodesColl
		$oNodeEnum_Temp = $oNodeEnum
		$sNodePath = ""
		$sNodePathTag = ""
		If $oNodeEnum.nodeType <> $NODE_DOCUMENT Then
			$sNameSpace = $oNodeEnum.namespaceURI()
			If $sNameSpace <> "" Then
				$sNameSpace = StringRight($sNameSpace, StringLen($sNameSpace) - StringInStr($sNameSpace, "/", 0, -1)) & ":"
			EndIf
			If $sNameSpace = 0 Then $sNameSpace = ""
			$sNodePath = "/" & $sNameSpace & $oNodeEnum.nodeName() & $sNodePath
		EndIf

		Do
			$oParent = $oNodeEnum_Temp.parentNode()
			; __XML_Misc_ConsoleNotifier("$oParent.nodeName()= " & $oParent.nodeName() & @LF)
			If $oParent.nodeType <> $NODE_DOCUMENT Then
				$sNameSpace = $oParent.namespaceURI()
				If $sNameSpace <> "" Then
					; $sNameSpace = StringRight($sNameSpace, StringLen($sNameSpace) - StringInStr($sNameSpace, "/", 0, -1)) & ":"
					$sNameSpace &= ":"
				EndIf
				If $sNameSpace = 0 Then $sNameSpace = ""
				$sNodePath = "/" & $sNameSpace & $oParent.nodeName() & $sNodePath
				$oNodeEnum_Temp = $oParent
			Else
				$oNodeEnum_Temp = Null
			EndIf
			$oParent = Null
		Until (Not (IsObj($oNodeEnum_Temp)))

		; __XML_Misc_ConsoleNotifier("$sNodePath= " & $sNodePath & @LF)
		_XML_Array_AddName($aResponse, $sNodePath)
	Next

	$aResponse[0] = UBound($aResponse) - 1
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $aResponse)

EndFunc   ;==>_XML_GetNodesPath

; #FUNCTION# ===================================================================
; Name ..........: _XML_GetNodesPathInternal
; Description ...: Returns the path of a valid node object.
; Syntax ........: _XML_GetNodesPathInternal($oXML_Node)
; Parameters ....: $oXML_Node       - A valid node object
; Return values .: Success        - Path from root as string.
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
;                  Failure        - An empty string and @error set to 1.
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_GetNodesPathInternal(ByRef $oXML_Node)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	__XML_IsValidObject($oXML_Node)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $sNodePath = "/" & $oXML_Node.baseName
	Local $oParentNode = Null, $sNameSpace = ''

	Do
		$oParentNode = $oXML_Node.parentNode()
		; __XML_Misc_ConsoleNotifier("parent" & $oParentNode.nodeName() & ">" & @LF)

		If $oParentNode.nodeType <> $NODE_DOCUMENT Then
			$sNameSpace = $oParentNode.namespaceURI()
			If $sNameSpace = 0 Then $sNameSpace = ""
			If $sNameSpace <> "" Then
				$sNameSpace = StringRight($sNameSpace, StringLen($sNameSpace) - StringInStr($sNameSpace, "/", 0, -1)) & ":"
			EndIf
			$sNodePath = "/" & $sNameSpace & $oParentNode.nodeName() & $sNodePath
			$oXML_Node = $oParentNode
		Else
			$oXML_Node = Null
		EndIf

		$oParentNode = Null
	Until (Not (IsObj($oXML_Node)))

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $sNodePath)

EndFunc   ;==>_XML_GetNodesPathInternal

; #FUNCTION# =====================================================================
; Name ..........: _XML_GetParentNodeName
; Description ...: Gets the parent node name of the node pointed to by the XPath
; Syntax ........: _XML_GetParentNodeName($sXPath)
; Parameters ....: $sXPath - IN - ; TODO
; Return values .: ???
; Author ........: Mike Rerick
; Modified.......:
; Remarks .......: Returns empty string if the XPath is not valid
; Related .......:
; Link ..........:
; Example .......: [yes/no]
; ================================================================================
Func _XML_GetParentNodeName(ByRef $oXmlDoc, $sXPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	If _XML_Misc_GetDomVersion() < 4 Then
		Return SetError($XMLWRAPPER_ERROR_DOMVERSION, 4, $XMLWRAPPER_RESULT_FAILURE) ; TODO @extended Description
	EndIf

	Local $oNodesColl = $oXmlDoc.selectNodes($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Local $aResponse[1], $sNodePath, $sNameSpace = ''
	Local $sParentNodeName = "", $oParent_Node = Null
	Local $sNodePathTag ; TODO QUESTION: $sNodePathTag What is For ?
	#forceref $sNodePathTag

	For $oNodeEnum In $oNodesColl
		Local $oNodeEnum1 = $oNodeEnum
		$sNodePath = ""
		$sNodePathTag = ""
		If $oNodeEnum.nodeType <> $NODE_DOCUMENT Then
			$sNameSpace = $oNodeEnum.namespaceURI()
			If $sNameSpace <> "" Then
				$sNameSpace = StringRight($sNameSpace, StringLen($sNameSpace) - StringInStr($sNameSpace, "/", 0, -1)) & ":"
			EndIf
			If $sNameSpace = 0 Then $sNameSpace = ""
			$sNodePath = "/" & $sNameSpace & $oNodeEnum.nodeName() & $sNodePath
		EndIf

		$oParent_Node = $oNodeEnum1.parentNode()
		If $oParent_Node.nodeType <> $NODE_DOCUMENT Then
			$sNameSpace = $oParent_Node.namespaceURI()
			If $sNameSpace <> "" Then $sNameSpace &= ":"
			If $sNameSpace = 0 Then $sNameSpace = "" ; TODO Question: if this line Should be one line higher
			$sNodePath = "/" & $sNameSpace & $oParent_Node.nodeName() & $sNodePath
			$oNodeEnum1 = $oParent_Node
			$sParentNodeName = $oParent_Node.nodeName()
		Else
			$oNodeEnum1 = 0
		EndIf

		$oParent_Node = Null
		; __XML_Misc_ConsoleNotifier("Path node: " & $sNodePath & @LF)
		_XML_Array_AddName($aResponse, $sNodePath)
	Next

	$aResponse[0] = UBound($aResponse) - 1
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $sParentNodeName)

EndFunc   ;==>_XML_GetParentNodeName

; @DONE
; #FUNCTION# ===================================================================
; Name ..........: _XML_Load
; Description ...: Creates an instance of an XML file.
; Syntax.........: _XML_Load($sXML_FileFullPath[, $sNameSpace = ""[, $iDOM_Version = -1[, $bValidateOnParse = True]]])
; Parameters ....: $sXML_FileFullPath    - the XML file to open
;                  $sNameSpace    - the namespace to specifiy if the file uses one.
;                  $iDOM_Version          - specifically try to use the version supplied here.
;                  $bValidateOnParse   - validate the document as it is being parsed
; Return values .: Success        - $oXmlDoc
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: Tom Hohmann, mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_Load
; Description ...: Load XML file to the existing object or declared empty variable.
; Syntax ........: _XML_Load(Byref $oXmlDoc, $sXML_FileFullPath[, $sNameSpace = ""[, $iDOM_Version = -1[, $bValidateOnParse = True]]])
; Parameters ....: $oXmlDoc             - [in/out] an object.
;                  $sXML_FileFullPath   - a string value.
;                  $sNameSpace          - [optional] a string value. Default is "".
;                  $iDOM_Version        - [optional] an integer value. Default is -1.
;                  $bValidateOnParse    - [optional] a boolean value. Default is True.
; Return values .: None
; Author ........: Your Name
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_Load
; Description ...:
; Syntax ........: _XML_Load(Byref $oXmlDoc, $sXML_FileFullPath[, $sNameSpace = ""[, $bValidateOnParse = True]])
; Parameters ....: $oXmlDoc             - [in/out] an object.
;                  $sXML_FileFullPath   - a string value.
;                  $sNameSpace          - [optional] a string value. Default is "".
;                  $bValidateOnParse    - [optional] a boolean value. Default is True.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_Load(ByRef $oXmlDoc, $sXML_FileFullPath, $sNameSpace = "", $bValidateOnParse = True)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	If Not FileExists($sXML_FileFullPath) Then Return SetError($XMLWRAPPER_ERROR_LOAD, 0, $XMLWRAPPER_RESULT_FAILURE)

	If _XML_Misc_GetDomVersion() > 4 Then $oXmlDoc.setProperty("ProhibitDTD", False)
	$oXmlDoc.async = False
	$oXmlDoc.preserveWhiteSpace = True
	$oXmlDoc.validateOnParse = $bValidateOnParse
	$oXmlDoc.Load($sXML_FileFullPath)
	If $oXmlDoc.parseError.errorCode Then
		Return SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	; SelectionLanguage do not use this as this cause a problem
	; $oXmlDoc.setProperty("SelectionLanguage", "XPath")

	$oXmlDoc.setProperty("SelectionNamespaces", $sNameSpace)

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $oXmlDoc)

EndFunc   ;==>_XML_Load

; #FUNCTION# ===================================================================
; Name ..........: _XML_LoadXML
; Description ...: Creates an instance for a string of XML .
; Syntax.........: _XML_LoadXML($sXML_Content[,$sNameSpace=""[, $iDOM_Version = -1[, $bValidateOnParse = True]]])
; Parameters ....: $sXML_Content        - The XML string to load into the document
;                  $sNameSpace    - the namespace to specifiy if the file uses one.
;                  $iDOM_Version          - specifically try to use the version supplied here.
;                  $bValidateOnParse   - Set the MSXML ValidateOnParse property
; Return values .: Success        - $oXmlDoc
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
;                  |1 - failed to create object, @extended = MSXML reason
;                  |2 - no object found (MSXML required for _XML functions)
; Author ........: Stephen Podhajecki, Lukasz Suleja, Tom Hohmann
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_LoadXML(ByRef $oXmlDoc, $sXML_Content, $sNameSpace = "", $bValidateOnParse = True)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	If _XML_Misc_GetDomVersion() > 4 Then $oXmlDoc.setProperty("ProhibitDTD", False)
	$oXmlDoc.async = False
	$oXmlDoc.preserveWhiteSpace = True
	$oXmlDoc.validateOnParse = $bValidateOnParse
	$oXmlDoc.LoadXml($sXML_Content)
	If $oXmlDoc.parseError.errorCode Then
		Return SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	; SelectionLanguage do not use this as this cause a problem
	; $oXmlDoc.setProperty("SelectionLanguage", "XPath")

	$oXmlDoc.setProperty("SelectionNamespaces", $sNameSpace)
	; TODO this following line was here, actualy I (mLipok) wondering why.
	; "xmlns:ms='urn:schemas-microsoft-com:xslt'"
	; here I put some reference to look in
	; https://msdn.microsoft.com/en-us/library/ms256186(v=vs.110).aspx

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $oXmlDoc)

EndFunc   ;==>_XML_LoadXML

; DONE
; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_NodeExists
; Description ...: Checks for the existence of a node matching the specified path
; Syntax ........: _XML_NodeExists(Byref $oXmlDoc, $sXPath)
; Parameters ....: $oXmlDoc             - [in/out] an object.
;                  $sXPath              - a string value. The XML tree path from root node (root/child/child..)
; Return values .: Success        	- $XMLWRAPPER_RESULT_SUCCESS
;                  Failure			- $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......; [yes/no]
; ===============================================================================================================================
Func _XML_NodeExists(ByRef $oXmlDoc, $sXPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNode_Selected = $oXmlDoc.selectSingleNode($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf $oNode_Selected = Null Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf Not IsObj($oNode_Selected) Then ; https://www.autoitscript.com/forum/topic/177176-why-isobj-0-and-vargettype-object/
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If IsObj($oNode_Selected) Then Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

EndFunc   ;==>_XML_NodeExists

; @WIP
; #FUNCTION# ===================================================================
; Name ..........: _XML_RemoveAttribute
; Description ...: Delete XML Attribute based on XPath input from root node.
; Syntax.........: _XML_RemoveAttribute($sXPath, $sAttribute_name)
; Parameters ....: $sXPath      - The XML tree path from root node (root/child/child..)
;                  $sAttribute_name  - The attribute node to delete
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_RemoveAttribute
; Description ...: Delete XML Attribute based on XPath input from root node.
; Syntax ........: _XML_RemoveAttribute(Byref $oXmlDoc, $sXPath, $sAttribute_name)
; Parameters ....: $oXmlDoc             - [in/out] an object.
;                  $sXPath              - a string value.
;                  $sAttribute_name     - a string value.
; Return values .: None
; Author ........: Your Name
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_RemoveAttribute(ByRef $oXmlDoc, $sXPath, $sAttribute_Name)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNode_Selected = $oXmlDoc.selectSingleNode($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf $oNode_Selected = Null Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf Not IsObj($oNode_Selected) Then ; https://www.autoitscript.com/forum/topic/177176-why-isobj-0-and-vargettype-object/
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Local $oAttribute = $oNode_Selected.getAttributeNode($sAttribute_Name)
	If Not (IsObj($oAttribute)) Then
		Return SetError($XMLWRAPPER_ERROR_NOATTRMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	; https://msdn.microsoft.com/en-us/library/ms757848(v=vs.85).aspx
	Local $iAttributesLength = $oNode_Selected.attributes.length
	Local $oAttribute_Removed = $oNode_Selected.removeAttributeNode($oAttribute)

	If Not IsObj($oAttribute_Removed) Or ($iAttributesLength = 1 + $oNode_Selected.attributes.length) Then
		Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)
	Else
		Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

EndFunc   ;==>_XML_RemoveAttribute

; #FUNCTION# ===================================================================
; Name ..........: _XML_RemoveAttributeNode
; Description ...: Delete XML Attribute node based on XPath input from root node.
; Syntax.........: _XML_RemoveAttributeNode($sXPath, $sAttribute)
; Parameters ....: $sXPath      - XML tree path from root node (root/child/child..)
;                  $sAttribute     - The attribute node to delete
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
;                  |0 - No error
;                  |1 - Error removing node
;                  |2 - No object
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_RemoveAttributeNode(ByRef $oXmlDoc, $sXPath, $sAttribute)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNode_Selected = $oXmlDoc.selectSingleNode($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf $oNode_Selected = Null Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf Not IsObj($oNode_Selected) Then ; https://www.autoitscript.com/forum/topic/177176-why-isobj-0-and-vargettype-object/
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Local $oAttribute = $oNode_Selected.removeAttributeNode($oNode_Selected.getAttributeNode($sAttribute))
	If IsObj($oAttribute) Then
		Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)
	EndIf

	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

EndFunc   ;==>_XML_RemoveAttributeNode

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_ReplaceChild
; Description ...: Replaces selected nodes with another
; Syntax ........: _XML_ReplaceChild(Byref $oXmlDoc, $sXPath, $sNodeNew_Name[, $sNameSpace = ""])
; Parameters ....: $oXmlDoc             - [in/out] an object.
;                  $sXPath              - a string value. The XML tree path from root node (root/child/child..)
;                  $sNodeNew_Name       - a string value. The replacement node name.
;                  $sNameSpace          - [optional] a string value. Default is "".
; Return values .: None
; Author ........: Stephen Podhajecki adapted from http://www.perfectxml.com/msxmlAnswers.asp?Row_ID=65
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........: http://www.perfectxml.com/msxmlAnswers.asp?Row_ID=65
; Example .......; yes
; ===============================================================================================================================
Func _XML_ReplaceChild(ByRef $oXmlDoc, $sXPath, $sNodeNew_Name, $sNameSpace = "")
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNodesColl_old = $oXmlDoc.documentElement.selectNodes($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl_old)) Or $oNodesColl_old.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Local $oNodeNew = Null
	For $oNodeEnum_old In $oNodesColl_old

		; Create a New Node element
		$oNodeNew = $oXmlDoc.createNode($NODE_ELEMENT, $sNodeNew_Name, $sNameSpace)
		If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

		; Copy all attributes
		For $oAttributeEnum In $oNodeEnum_old.Attributes
			$oNodeNew.Attributes.setNamedItem($oAttributeEnum.cloneNode(True))
		Next

		; Copy all Child Nodes
		For $oNodeEnum_old_Child In $oNodeEnum_old.childNodes
			$oNodeNew.appendChild($oNodeEnum_old_Child)
			If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)
		Next

		; Replace the specified $oNodeEnum_old with the supplied $oNodeNew
		$oNodeEnum_old.parentNode.replaceChild($oNodeNew, $oNodeEnum_old)
		If $oXmlDoc.parseError.errorCode Then
			Return SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
		EndIf

	Next

	$oNodesColl_old = Null
	$oNodeNew = Null

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

EndFunc   ;==>_XML_ReplaceChild

; #FUNCTION# ===================================================================
; Name ..........: _XML_SaveToFile
; Description ...: Save the current xml doc
; Syntax ........: _XML_SaveToFile(Byref $oXmlDoc[, $sXML_FileFullPath = Default[, $bForce = False]])
; Parameters ....: $oXmlDoc - [in/out] an object.
;                  $sXML_FileFullPath         - [optional] a string value. Default is Default. The filename to save the xml doc as.
;                  $bForce        - If true, save the file regardless of autosave state.
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
;                  |1 - error trying to save.
;                  |2 - Autosave is off.
;                  |3 - No filename given for save and default is blank.
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......: Defaults to the current filename.
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_SaveToFile(ByRef $oXmlDoc, $sXML_FileFullPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	If StringInStr(FileGetAttrib($sXML_FileFullPath), "R") Then
		Return SetError($XMLWRAPPER_ERROR_SAVEFILERO, 0, $XMLWRAPPER_RESULT_FAILURE)

	EndIf

	If $sXML_FileFullPath <> "" And IsString($sXML_FileFullPath) Then
		$oXmlDoc.save($sXML_FileFullPath)
		If $oXmlDoc.parseError.errorCode Then
			Return SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
		EndIf
		Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

	EndIf

	Return SetError($XMLWRAPPER_ERROR_SAVE, 0, $XMLWRAPPER_RESULT_FAILURE)

EndFunc   ;==>_XML_SaveToFile

; @DONE
; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_SelectNodes
; Description ...: Selects XML Node(s) based on XPath input from root node.
; Syntax ........: _XML_SelectNodes(Byref $oXmlDoc, $sXPath)
; Parameters ....: $oXmlDoc       - [in/out] an object.
;                  $sXPath              - a string value. The XML tree path from root node (root/child/child..)
; Return values .: Success        		- $oNodesColl - Nodes collection
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......; [yes/no]
; ===============================================================================================================================
Func _XML_SelectNodes(ByRef $oXmlDoc, $sXPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNodesColl = $oXmlDoc.selectNodes($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $oNodesColl)

EndFunc   ;==>_XML_SelectNodes

; #FUNCTION# ===================================================================
; Name ..........: _XML_Transform
; Description ...:
; Syntax ........: _XML_Transform(Byref $oXmlDoc[, $sXSL_FileFullPath = ""])
; Parameters ....: $oXmlDoc       - [in/out] an object. The XML document to transform
;                  $sXSL_FileFullPath         - The stylesheet to use
; Return values .: Success        - Returns True
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki , Modified by WeaponX
; Modified ......: mLipok
; Remarks .......: Ref XML Object will be overwriten - will contain Transformed Data
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_Transform(ByRef $oXmlDoc, $sXSL_FileFullPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	If Not (FileExists($sXSL_FileFullPath)) Then
		Return SetError($XMLWRAPPER_ERROR_LOAD, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Local $oXSLT_Template = ObjCreate("Msxml2.XSLTemplate." & _XML_Misc_GetDomVersion() & ".0")
	Local $oXSL_Document = ObjCreate("Msxml2.FreeThreadedDOMDocument." & _XML_Misc_GetDomVersion() & ".0")
	Local $oXmlDoc_Temp = ObjCreate("Msxml2.DOMDocument." & _XML_Misc_GetDomVersion() & ".0")

	$oXSL_Document.async = False
	$oXSL_Document.load($sXSL_FileFullPath)
	If $oXSL_Document.parseError.errorCode Then
		Return SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	$oXSLT_Template.stylesheet = $oXSL_Document
	Local $oXSL_Processor = $oXSLT_Template.createProcessor()
	$oXSL_Processor.input = $oXmlDoc

	$oXmlDoc_Temp.transformNodeToObject($oXSL_Document, $oXmlDoc)
	If $oXSL_Document.parseError.errorCode Then
		Return SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc_Temp.parseError.errorCode, $oXmlDoc_Temp.parseError.reason)
	EndIf

	; Replace oryginal document obecject
	$oXmlDoc = $oXmlDoc_Temp

	; CleanUp
	$oXSL_Processor = Null
	$oXSLT_Template = Null
	$oXSL_Document = Null
	$oXmlDoc_Temp = Null

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

EndFunc   ;==>_XML_Transform

; #FUNCTION# ===================================================================
; Name ..........: _XML_UpdateField
; Description ...: Update existing single node based on XPath specs.
; Syntax.........: _XML_UpdateField($sXPath, $sData)
; Parameters ....: $sXPath      - Path from root node.
;                  $sData       - The data to update the node with.
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: Weaponx, mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_UpdateField(ByRef $oXmlDoc, $sXPath, $sData)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $bUpdateStatus = False
	Local $oNode_Selected = $oXmlDoc.selectSingleNode($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf $oNode_Selected = Null Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf Not IsObj($oNode_Selected) Then ; https://www.autoitscript.com/forum/topic/177176-why-isobj-0-and-vargettype-object/
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	; TODO remove this following line
	If IsObj($oNode_Selected) Then

		If $oNode_Selected.hasChildNodes Then
			For $oNodeEnum_Child In $oNode_Selected.childNodes()
				If $oNodeEnum_Child.nodetype = $NODE_TEXT Then
					$oNodeEnum_Child.Text = $sData
					$bUpdateStatus = True
					ExitLoop
				EndIf
			Next
		EndIf

		If Not $bUpdateStatus Then
			Local $oNode_Created = $oXmlDoc.createTextNode($sData)
			$oNode_Selected.appendChild($oNode_Created)
			If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

		EndIf

		$oNode_Selected = Null
		Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

	EndIf

	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

EndFunc   ;==>_XML_UpdateField

; #FUNCTION# ===================================================================
; Name ..........: _XML_UpdateField2
; Description ...: Update existing node(s) based on XPath specs.
; Syntax.........: _XML_UpdateField2($sXPath, $sData)
; Parameters ....: $sXPath - Path from root node.
;                  $sData - The data to update the node with.
; Return values .: Success - 1
; Author ........: Stephen Podhajecki
; Modified.......: Weaponx, mLipok
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: [yes/no]
; ================================================================================
Func _XML_UpdateField2(ByRef $oXmlDoc, $sXPath, $sData)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNodesColl = $oXmlDoc.documentElement.selectNodes($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	; __XML_Misc_ConsoleNotifier("GetValue list length:" & $oNodesColl.length)
	For $oNodeEnum In $oNodesColl
		If $oNodeEnum.hasChildNodes() Then
			For $oNodeEnum_Child In $oNodeEnum.childNodes()
				If $oNodeEnum_Child.nodetype = $NODE_TEXT Then
					$oNodeEnum_Child.Text = $sData
					ExitLoop
				EndIf
			Next
		Else
			; TODO What here ???
		EndIf
	Next
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

EndFunc   ;==>_XML_UpdateField2

; #FUNCTION# ===================================================================
; Name ..........: _XML_Validate_File
; Description ...: Validates a document against a dtd.
; Syntax.........: _XML_Validate_File($sXMLFile, $sNameSpace, $sXSD_FileFullPath)
; Parameters ....: $sXMLFile      - The file to validate
;                  $sNameSpace    - xml namespace
;                  $sXSD_FileFullPath      - DTD file to validate against.
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......: 	; TODO: Add such function but to work with object instead files ( I mean in memory validation )
; Related .......:
; Link ..........; https://msdn.microsoft.com/en-us/library/ms760267(v=vs.85).aspx
; Example .......; [yes/no]
; ==============================================================================
Func _XML_Validate_File($sXMLFile, $sNameSpace, $sXSD_FileFullPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	Local $oXmlDoc = _XML_CreateObject()
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oXML_SchemaCache = ObjCreate("Msxml2.XMLSchemaCache." & _XML_Misc_GetDomVersion() & ".0")
	If Not IsObj($oXML_SchemaCache) Then
		; TODO Magic Number Remove
		Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

	EndIf
	$oXML_SchemaCache.add($sNameSpace, $sXSD_FileFullPath)
	$oXmlDoc.schemas = $oXML_SchemaCache
	$oXmlDoc.async = False
	$oXmlDoc.ValidateOnParse = False

	$oXmlDoc.load($sXMLFile)
	$oXmlDoc.validate()

	If $oXmlDoc.parseError.errorCode Then
		Return SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

EndFunc   ;==>_XML_Validate_File

; #FUNCTION# ===================================================================
; Name ..........: _XMLCreateCDATA
; Description ...: Create a CDATA SECTION node directly under root.
; Syntax.........: _XMLCreateCDATA($sNode, $sCDATA[, $sNameSpace = ""])
; Parameters ....: $sNode       - name of node to create
;                  $sCDATA       - CDATA value
;                  $sNameSpace    - the namespace to specifiy if the xml uses one.
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......: fixme, won't append to exisiting node. must create new node.
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XMLCreateCDATA(ByRef $oXmlDoc, $sNode, $sCDATA, $sNameSpace = "")
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNode = $oXmlDoc.createNode($NODE_ELEMENT, $sNode, $sNameSpace)
	If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

	If IsObj($oNode) Then
		If Not ($oNode.hasChildNodes()) Then
			__AddFormat($oXmlDoc, $oNode)
		EndIf
		Local $oChild = $oXmlDoc.createCDATASection($sCDATA)
		$oNode.appendChild($oChild)
		If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

		$oXmlDoc.documentElement.appendChild($oNode)
		If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

		__AddFormat($oXmlDoc)
		$oChild = Null
		Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

	EndIf

	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

EndFunc   ;==>_XMLCreateCDATA

; #FUNCTION# ===================================================================
; Name ..........: _XMLCreateChildNode
; Description ...: Create a child node under the specified XPath Node.
; Syntax.........: _XMLCreateChildNode($sXPath, $sNode[, $sData = ""[, $sNameSpace = ""]])
; Parameters ....: $sXPath      - The node from root.
;                  $sNode       - Node name to add.
;                  $sData       - Value to give the node
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XMLCreateChildNode(ByRef $oXmlDoc, $sXPath, $sNode, $sData = "", $sNameSpace = "")
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNodesColl = $oXmlDoc.selectNodes($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Local $oChild
	For $oNodeEnum In $oNodesColl
		If Not ($oNodeEnum.hasChildNodes()) Then
			__AddFormat($oXmlDoc, $oNodeEnum)
		EndIf
		If $sNameSpace = "" Then
			If Not ($oNodeEnum.namespaceURI = 0 Or $oNodeEnum.namespaceURI = "") Then $sNameSpace = $oNodeEnum.namespaceURI
		EndIf

		$oChild = $oXmlDoc.createNode($NODE_ELEMENT, $sNode, $sNameSpace)
		If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

		If $sData <> "" Then $oChild.text = $sData
		$oNodeEnum.appendChild($oChild)
		If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

		__AddFormat($oXmlDoc, $oNodeEnum)
	Next

	$oNodesColl = Null
	$oChild = Null
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

EndFunc   ;==>_XMLCreateChildNode

; #FUNCTION# ===================================================================
; Name ..........: _XMLCreateChildNodeWAttr
; Description ...: Create a child node(s) under the specified XPath Node with attributes.
; Syntax.........: _XMLCreateChildNodeWAttr($sXPath, $sNode, $aAttribute, $aValue[, $sData = ""[, $sNameSpace = ""]])
; Parameters ....: $sPath         - Path from root
;                  $sNode         - The node to add with attibute(s)
;                  $aAttribute         - The attribute name(s) -- can be array
;                  $aValue          - The	attribute value(s) -- can be array
;                  $sData       - The optional value to give the child node.
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
;                  |1 - Could not create node.
;                  |2 - Mismatch between attribute name and value counts.
;                  |3 - Attribute Name cannot be empty string.
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......: This function requires that each attribute name has a corresponding value.
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XMLCreateChildNodeWAttr(ByRef $oXmlDoc, $sXPath, $sNode, $aAttribute, $aValue, $sData = "", $sNameSpace = "")
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Return SetError($XMLWRAPPER_ERROR_OK, 0, _XML_CreateChildWAttr($sXPath, $sNode, $aAttribute, $aValue, $sData, $sNameSpace))

EndFunc   ;==>_XMLCreateChildNodeWAttr

; #FUNCTION# ===================================================================
; Name ..........: _XMLCreateFile
; Description ...: Create a new blank metafile with header.
; Syntax.........: _XMLCreateFile($sXML_FileFullPath, $sRoot[, $bOverwrite = False[, $bUTF8 = False[, $ver = -1]]])
; Parameters ....: $sXML_FileFullPath       - The xml filename with full path to create
;                  $sRoot       - The root of the xml file to create
;                  $bOverwrite    - boolean flag to auto overwrite existing file of same name.
;                  $bUTF8         - boolean flag to specify UTF-8 encoding in header.
;                  $iDOM_Version          - specifically try to use the version supplied here.
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
;                  |0 - No error
;                  |1 - Failed to create file
;                  |2 - No object
;                  |3 - File creation failed MSXML error
;                  |4 - File exists
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......: Use _XML_Load after using this function to access the file. (PsaltyDS)
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XMLCreateFile($sXML_FileFullPath, $sRoot, $bOverwrite = False, $bUTF8 = False, $iDOM_Version = -1)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	; TODO $bUTF8 = False -- change to $iEncoding = $FO_UTF8_NOBOM
	If FileExists($sXML_FileFullPath) = 1 And Not $bOverwrite Then
		Return SetError($XMLWRAPPER_ERROR_SAVE, 0, $XMLWRAPPER_RESULT_FAILURE)

	Else
		FileCopy($sXML_FileFullPath, $sXML_FileFullPath & ".bak", 1)
		FileDelete($sXML_FileFullPath)
	EndIf

	Local $oXmlDoc = _XML_CreateObject($iDOM_Version)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oProcessingInstruction = $oXmlDoc.createProcessingInstruction("xml", "version=""1.0""" & ($bUTF8) ? """encoding=""UTF-8""" : "")

	$oXmlDoc.appendChild($oProcessingInstruction)
	If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

	Local $oXML_RootElement = $oXmlDoc.createElement($sRoot)
	$oXmlDoc.documentElement = $oXML_RootElement

	; TODO use _XML_SaveToFile
	$oXmlDoc.save($sXML_FileFullPath)
	If @error Then Return SetError($XMLWRAPPER_ERROR_SAVE, 0, $XMLWRAPPER_RESULT_FAILURE)

	If $oXmlDoc.parseError.errorCode Then
		Return SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	; CleanUp
	$oXmlDoc = Null
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

EndFunc   ;==>_XMLCreateFile

; #FUNCTION# ===================================================================
; Name ..........: _XMLCreateRootChild
; Description ...: Create node directly under root.
; Syntax.........: _XMLCreateRootChild($sNode[, $sData = ""[, $sNameSpace = ""]])
; Parameters ....: $sNode       - The name of node to create.
;                  $sData       - The optional value to create
;                  $$sNameSpace   - the namespace to specifiy if the file uses one.
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XMLCreateRootChild(ByRef $oXmlDoc, $sNode, $sData = "", $sNameSpace = "")
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	;ConsoleWrite("_XMLCreateRootChild:"&$sNode&@LF)

	If Not ($oXmlDoc.documentElement.hasChildNodes()) Then
		__AddFormat($oXmlDoc)
	EndIf

	Local $oChild = $oXmlDoc.createNode($NODE_ELEMENT, $sNode, $sNameSpace)
	If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

	If IsObj($oChild) Then
		If $sData <> "" Then $oChild.text = $sData
		$oXmlDoc.documentElement.appendChild($oChild)
		If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

		__AddFormat($oXmlDoc)
		$oChild = 0
		Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)
	EndIf

	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

EndFunc   ;==>_XMLCreateRootChild

; #FUNCTION# ===================================================================
; Name ..........: _XMLCreateRootNodeWAttr
; Description ...: Create a child node under root node with attributes.
; Syntax.........: _XMLCreateRootNodeWAttr($sNode, $aAttribute_Names, $aAttribute_Values[, $sData = ""[, $sNameSpace = ""]])
; Parameters ....: $sNode       - The node to add with attibute(s)
;                  $aAttribute_Names         - The attribute name(s) -- can be array
;                  $aAttribute_Values          - The	attribute value(s) -- can be array
;                  $sData       - The optional value to give the node.
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
;                  |1 - Could not create node.
;                  |2 - Mismatch between attribute name and value counts.
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......: This function requires that each attribute name has a corresponding value.
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XMLCreateRootNodeWAttr(ByRef $oXmlDoc, $sNode, $aAttribute_Names, $aAttribute_Values, $sData = "", $sNameSpace = "")
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oChild_Node = $oXmlDoc.createNode($NODE_ELEMENT, $sNode, $sNameSpace)
	If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

	If IsObj($oChild_Node) Then
		If $sData <> "" Then $oChild_Node.text = $sData
		If Not ($oXmlDoc.documentElement.hasChildNodes()) Then
			__AddFormat($oXmlDoc)
		EndIf

		Local $oAttribute = Null
		#forceref $oAttribute
		If IsArray($aAttribute_Names) And IsArray($aAttribute_Values) Then
			If UBound($aAttribute_Names) <> UBound($aAttribute_Values) Then
				Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)
			EndIf

			For $iAttribute_idx = 0 To UBound($aAttribute_Names) - 1
				If $aAttribute_Names[$iAttribute_idx] = "" Then
					Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)
				EndIf

				$oAttribute = $oXmlDoc.createAttribute($aAttribute_Names[$iAttribute_idx]);, $sNameSpace) ; TODO Check why $sNameSpace
				$oChild_Node.SetAttribute($aAttribute_Names[$iAttribute_idx], $aAttribute_Values[$iAttribute_idx])
			Next
		Else
			$oAttribute = $oXmlDoc.createAttribute($aAttribute_Names)
			$oChild_Node.SetAttribute($aAttribute_Names, $aAttribute_Values)
		EndIf
		$oXmlDoc.documentElement.appendChild($oChild_Node)
		If @error Then Return SetError($XMLWRAPPER_ERROR_NODECREATEAPPEND, 0, $XMLWRAPPER_RESULT_FAILURE)

		__AddFormat($oXmlDoc)
		$oChild_Node = Null
		Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)
	EndIf

	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

EndFunc   ;==>_XMLCreateRootNodeWAttr

; #FUNCTION# ===================================================================
; Name ..........: _XMLGetAllAttrib
; Description ...: Get all XML Field(s) attributes based on XPath input from root node.
; Syntax.........: _XMLGetAllAttrib($sXPath, ByRef $aName, ByRef $aValue[, $sQuery = ""])
; Parameters ....: $sXPath      - XML tree path from root node (root/child/child..)
;                  $aName         - The array to return the attrib names
;                  $aValue        - The array to return the attrib values
;                  $sQuery      - DOM compliant query string (not really necessary as it becomes part of the path)
; Return values .: Success        - array of fields text values(number of items is in [0][0])
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XMLGetAllAttrib(ByRef $oXmlDoc, $sXPath, ByRef $aName, ByRef $aValue, $sQuery = "")
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNodesColl = $oXmlDoc.selectNodes($sXPath & $sQuery)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Local $oAttributesColl
	Local $aResponse[2][1]
	For $oNodeEnum In $oNodesColl
		$oAttributesColl = $oNodeEnum.attributes
		If ($oAttributesColl.length) = 0 Then
			ContinueLoop
			Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)
		EndIf

		; __XML_Misc_ConsoleNotifier("Get all attrib, $oAttributesColl.length= " & $oAttributesColl.length)
		ReDim $aResponse[2][$oAttributesColl.length + 2]
		ReDim $aName[$oAttributesColl.length]
		ReDim $aValue[$oAttributesColl.length]
		For $iAttribute_idx = 0 To $oAttributesColl.length - 1
			$aResponse[0][$iAttribute_idx + 1] = $oAttributesColl.item($iAttribute_idx).nodeName
			$aResponse[1][$iAttribute_idx + 1] = $oAttributesColl.item($iAttribute_idx).Value
			$aName[$iAttribute_idx] = $oAttributesColl.item($iAttribute_idx).nodeName
			$aValue[$iAttribute_idx] = $oAttributesColl.item($iAttribute_idx).Value
		Next

	Next
	$aResponse[0][0] = $oAttributesColl.length
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $aResponse)

EndFunc   ;==>_XMLGetAllAttrib

; #FUNCTION# ===================================================================
; Name ..........: _XMLGetField
; Description ...: Get XML Field(s) based on XPath input from root node.
; Syntax.........: _XMLGetField($sXPath)
; Parameters ....: $sXPath      - The XML tree path from root node (root/child/child..)
; Return values .: Success        - An array of fields text values(count is in first element)
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XMLGetField(ByRef $oXmlDoc, $sXPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $aResponse[1] = [0], $sNodePath
	Local $oNode_Selected = $oXmlDoc.selectSingleNode($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf $oNode_Selected = Null Then
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf Not IsObj($oNode_Selected) Then ; https://www.autoitscript.com/forum/topic/177176-why-isobj-0-and-vargettype-object/
		Return SetError($XMLWRAPPER_ERROR_NONODESMATCH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If $oNode_Selected.hasChildNodes() Then
		Local $iNodeMaxCount = $oNode_Selected.childNodes.length
		Local $oChild, $aRet
		#forceref $oChild ; TODO QUESTION: $oChild is for what ??
		For $iNode_idx = 1 To $iNodeMaxCount
			$oChild = $oNode_Selected.childNodes($iNode_idx)
			If $oNode_Selected.parentNode.nodeType = $NODE_DOCUMENT Then
				$sNodePath = "/" & $oNode_Selected.baseName & "/*[" & $iNode_idx & "]"
			Else
				$sNodePath = $oNode_Selected.baseName & "/*[" & $iNode_idx & "]"
			EndIf

			$aRet = _XMLGetValue($oXmlDoc, $sNodePath)
			If IsArray($aRet) Then
				If UBound($aRet) > 1 Then
					_XML_Array_AddName($aResponse, $aRet[1])
					; __XML_Misc_ConsoleNotifier("GetField>Text:" & $aRet[1])
				EndIf
			Else
				_XML_Array_AddName($aResponse, "")
				; __XML_Misc_ConsoleNotifier("GetField>Text:" & "")
			EndIf

		Next

		$aResponse[0] = UBound($aResponse) - 1
		Return SetError($XMLWRAPPER_ERROR_OK, $aResponse[0], $aResponse) ; TODO Description for @extended

	EndIf
	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)

EndFunc   ;==>_XMLGetField

; #FUNCTION# ===================================================================
; Name ..........: _XMLGetValue
; Description ...: Get XML values based on XPath input from root node.
; Syntax.........: _XMLGetValue($sXPath)
; Parameters ....: $sXPath      - xml tree path from root node (root/child/child..)
; Return values .: Success        - An array of fields text values(count is in first element)
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
;                  |0 - No matching node.
;                  |1 - No object passed.
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XMLGetValue(ByRef $oXmlDoc, $sXPath)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oNodesColl = $oXmlDoc.documentElement.selectNodes($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Local $aResponse[1]
	For $oNodeEnum In $oNodesColl
		If $oNodeEnum.hasChildNodes() Then
			For $oNodeEnum_Child In $oNodeEnum.childNodes()
				If $oNodeEnum_Child.nodeType = $NODE_CDATA_SECTION Then
					_XML_Array_AddName($aResponse, $oNodeEnum_Child.data)
					; __XML_Misc_ConsoleNotifier("GetValue>CData:" & $oNodeEnum_Child.data)
				ElseIf $oNodeEnum_Child.nodeType = $NODE_TEXT Then
					_XML_Array_AddName($aResponse, $oNodeEnum_Child.Text)
					; __XML_Misc_ConsoleNotifier("GetValue>Text:" & $oNodeEnum_Child.Text)
				EndIf
			Next
		Else
			_XML_Array_AddName($aResponse, $oNodeEnum.nodeValue)
		EndIf
	Next

	$aResponse[0] = UBound($aResponse) - 1
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $aResponse)

EndFunc   ;==>_XMLGetValue

; #FUNCTION# ===================================================================
; Name ..........: _XMLSetAttrib
; Description ...: Set XML Field(s) based on XPath input from root node.
; Syntax.........: _XMLSetAttrib($sXPath, $sAttribute[, $sValue = ""[, $iIndex =-1]])
; Parameters ....: $sXPath      - Xml tree path from root node (root/child/child..)
;                  $sAttribute     - The attribute to set.
;                  $sValue      - The value to give the attribute defaults to ""
;                  $iIndex        - Used to specify a specific index for "same named" nodes.
; Return values .: Success        - Anarray of fields text values
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XMLSetAttrib(ByRef $oXmlDoc, $sXPath, $sAttribute, $sValue = "", $iIndex = -1)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	_XML_UseEventHandler($oXmlDoc)
	__XML_IsValidObject($oXmlDoc)
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $aResponse[1]
	Local $oNodesColl = $oXmlDoc.selectNodes($sXPath)
	If @error Then
		Return SetError($XMLWRAPPER_ERROR_XPATH, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If (Not IsObj($oNodesColl)) Or $oNodesColl.length = 0 Then
		Return SetError($XMLWRAPPER_ERROR_EMPTYCOLLECTION, 0, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	If $iIndex > 0 Then
		$aResponse[0] = $oNodesColl.item($iIndex).SetAttribute($sAttribute, $sValue)
	Else
		ReDim $aResponse[$oNodesColl.length]
		For $iNode_idx = 0 To $oNodesColl.length - 1
			$aResponse[$iNode_idx] = $oNodesColl.item($iNode_idx).SetAttribute($sAttribute, $sValue)
			If $oXmlDoc.parseError.errorCode Then
				Return SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
			EndIf

		Next
	EndIf

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $aResponse)

EndFunc   ;==>_XMLSetAttrib
#Region XMLWrapperEx.au3 - Functions - Misc

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Name ..........: __XML_Misc_ConsoleNotifier
; Description ...: Writes a message to console with a crlf on the end
; Syntax ........: __XML_Misc_ConsoleNotifier($sMessage[, $sLineEnding = @LF])
; Parameters ....: $sMessage              - a string value. The message to display
;                  $sLineEnding         - [optional] a string value. Default is @LF. Line ending to add.
; Return values .: None
; Author ........: ??
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func __XML_Misc_ConsoleNotifier($sMessage, $sLineEnding = @LF)
	If _XML_MiscProperty_NotifyToConsole() Then
		ConsoleWrite(StringFormat($sMessage) & $sLineEnding)
	EndIf
EndFunc   ;==>__XML_Misc_ConsoleNotifier

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Name ..........: __XML_Misc_MsgBoxNotifier
; Description ...: displays a simple "ok" messagebox
; Syntax ........: __XML_Misc_MsgBoxNotifier($sNotifier_Msg, $sTitle)
; Parameters ....: $sNotifier_Msg - The message to display
;                  $sTitle              - [optional] a string value. Default is @ScriptName.
; Return values .: None.
; Author ........: ???
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func __XML_Misc_MsgBoxNotifier($sNotifier_Msg, $sTitle = @ScriptName, $bForce = False)
	; try also to put message to Console not only to MsgBox
	; __XML_Misc_ConsoleNotifier('MsgBoxNotifier: ' & (($sTitle = @ScriptName) ? "" : $sTitle & " ") & $sNotifier_Msg)

	; check if notification is enabled for MsgBox
	If _XML_MiscProperty_NotifyToMsgBox() Or $bForce Then
		MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, $sTitle, $sNotifier_Msg)
	EndIf

EndFunc   ;==>__XML_Misc_MsgBoxNotifier

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Name ..........: __XML_MiscProperty_DomVersion
; Description ...: TODO
; Syntax ........: __XML_MiscProperty_DomVersion([$sDomVersion = Default])
; Parameters ....: $sDomVersion         - [optional] a string value. Default is Default.
; Return values .: DOM Version
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func __XML_MiscProperty_DomVersion($sDomVersion = Default)
	Local Static $sDomVersion_Static = True

	If $sDomVersion = Default Then
	ElseIf IsNumber($sDomVersion) Then
		$sDomVersion_Static = $sDomVersion
	Else
		$sDomVersion_Static = -1
		__XML_Misc_MsgBoxNotifier('Incorrect DomVersion', 'XMLWrapperEx', True)
	EndIf

	Return $sDomVersion_Static

EndFunc   ;==>__XML_MiscProperty_DomVersion

; #FUNCTION# ===================================================================
; Name ..........: _XML_Misc_GetDomVersion
; Description ...: Returns the version of msxml that is in use for the document.
; Syntax.........: _XML_Misc_GetDomVersion()
; Parameters ....: none
; Return values .: Success        - msxml version
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_Misc_GetDomVersion()
	Return __XML_MiscProperty_DomVersion()
EndFunc   ;==>_XML_Misc_GetDomVersion

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_Misc_Viewer
; Description ...: Display XML Document in default system viewer
; Syntax ........: _XML_Misc_Viewer(Byref $oXmlDoc[, $sXML_FileFullPath = Default])
; Parameters ....: $oXmlDoc             - [in/out] an object.
;                  $sXML_FileFullPath   - [optional] a string value. Default is Default.
; Return values .: None - TODO
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_Misc_Viewer(ByRef $oXmlDoc, $sXML_FileFullPath = Default)
	If $sXML_FileFullPath = Default Then
		$sXML_FileFullPath = @ScriptDir & '\XMLDOM_Display_TestingFile.xml'
	EndIf

	_XML_SaveToFile($oXmlDoc, $sXML_FileFullPath)
	If @error Then
		Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	ShellExecute($sXML_FileFullPath)
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

EndFunc   ;==>_XML_Misc_Viewer

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_MiscProperty_AutoFormat
; Description ...: Get or set AutoFormat configuration
; Syntax ........: _XML_MiscProperty_AutoFormat([$bAutoFormat = Default])
; Parameters ....: $bAutoFormat              - [optional] a boolean value. Default is Default. Boolean value to set automatic formating.
; Return values .: The AutoFormat state.
; Author ........: mLipok
; Modified ......:
; Remarks .......: Defaults is True.
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_MiscProperty_AutoFormat($bAutoFormat = Default)
	Local Static $bAutoFormat_Static = True

	If $bAutoFormat = Default Then
	ElseIf IsBool($bAutoFormat) Then
		$bAutoFormat_Static = $bAutoFormat
	Else
		$bAutoFormat_Static = False
	EndIf

	Return $bAutoFormat_Static

EndFunc   ;==>_XML_MiscProperty_AutoFormat

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_MiscProperty_AutoSave
; Description ...: Get or set auto save configuration
; Syntax ........: _XML_MiscProperty_AutoSave([$bAutoSave = Default])
; Parameters ....: $bAutoSave              - [optional] a boolean value. Default is Default. Boolean value to set automatic saving.
; Return values .: The auto save state.
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......: Defaults is False.
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_MiscProperty_AutoSave($bAutoSave = Default)
	Local Static $bAutoSave_Static = False

	If $bAutoSave = Default Then
	ElseIf IsBool($bAutoSave) Then
		$bAutoSave_Static = $bAutoSave
	Else
		$bAutoSave_Static = False
	EndIf

	Return $bAutoSave_Static

EndFunc   ;==>_XML_MiscProperty_AutoSave

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_MiscProperty_Encoding
; Description ...: TODO
; Syntax ........: _XML_MiscProperty_Encoding([$sEncoding = Default])
; Parameters ....: $sEncoding             - [optional] a string value. Default is Default.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_MiscProperty_Encoding($sEncoding = Default)
	Local Static $sEncoding_Static = Default

	If $sEncoding = Default Then
		If $sEncoding_Static = Default Then
			Switch @OSLang
				Case 0415 ; 'pl-PL'
					$sEncoding_Static = 'ISO-8859-2'
				Case Else
					$sEncoding_Static = 'ISO-8859-1'
			EndSwitch
		EndIf
		Return $sEncoding_Static

	ElseIf IsString($sEncoding) Then
		$sEncoding_Static = $sEncoding
		Return $sEncoding_Static

	Else
		$sEncoding_Static = False
		Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $sEncoding_Static)

	EndIf

EndFunc   ;==>_XML_MiscProperty_Encoding

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_MiscProperty_EventHandling
; Description ...: Get or set EventHandling configuration
; Syntax ........: _XML_MiscProperty_EventHandling([$bEventHandling = Default])
; Parameters ....: $bEventHandling              - [optional] a boolean value. Default is Default. Boolean value to set automatic formating.
; Return values .: The EventHandling state.
; Author ........: mLipok
; Modified ......:
; Remarks .......: Defaults is True.
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_MiscProperty_EventHandling($bEventHandling = Default)
	Local Static $bEventHandling_Static = False

	If $bEventHandling = Default Then
	ElseIf IsBool($bEventHandling) Then
		$bEventHandling_Static = $bEventHandling
	Else
		$bEventHandling_Static = False
	EndIf

	Return $bEventHandling_Static

EndFunc   ;==>_XML_MiscProperty_EventHandling

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_MiscProperty_Notify
; Description ...: TODO
; Syntax ........: _XML_MiscProperty_Notify([$bNotify = Default])
; Parameters ....: $bNotify             - [optional] a boolean value. Default is Default.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_MiscProperty_Notify($bNotify = Default)
	Local Static $bNotify_Static = True

	If $bNotify = Default Then
		Return $bNotify_Static
	ElseIf IsBool($bNotify) Then
		$bNotify_Static = $bNotify
		Return $bNotify_Static
	Else
		$bNotify_Static = False
		Return $bNotify_Static
	EndIf

	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $bNotify_Static)

EndFunc   ;==>_XML_MiscProperty_Notify

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_MiscProperty_NotifyAll
; Description ...: Enable / Disable entire UDF notification system
; Syntax ........: _XML_MiscProperty_NotifyAll($bNotifyAll)
; Parameters ....: $bNotifyAll          - a boolean value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_MiscProperty_NotifyAll($bNotifyAll)
	If IsBool($bNotifyAll) Then
		_XML_MiscProperty_Notify($bNotifyAll)
		_XML_MiscProperty_NotifyToConsole($bNotifyAll)
		_XML_MiscProperty_NotifyToMsgBox($bNotifyAll)
		_XML_MiscProperty_EventHandling($bNotifyAll)
	EndIf
EndFunc   ;==>_XML_MiscProperty_NotifyAll

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_MiscProperty_NotifyToConsole
; Description ...: Get or set debugging configuration
; Syntax ........: _XML_MiscProperty_NotifyToConsole([$bDebug = Default])
; Parameters ....: $bDebug              - [optional] a boolean value. Default is Default > GetState. Boolean value for debugging.
; Return values .: The debugging state.
; Author ........: Stephen Podhajecki
; Modified ......: mLipok
; Remarks .......: Default is False
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_MiscProperty_NotifyToConsole($bDebug = Default)
	Local Static $bDebug_Static = False

	If $bDebug = Default Then
		If $bDebug_Static = Default Then $bDebug_Static = True

	ElseIf IsBool($bDebug) Then
		$bDebug_Static = $bDebug
	Else
		$bDebug_Static = False
	EndIf

	Return $bDebug_Static

EndFunc   ;==>_XML_MiscProperty_NotifyToConsole

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_MiscProperty_NotifyToMsgBox
; Description ...: TODO
; Syntax ........: _XML_MiscProperty_NotifyToMsgBox([$bNotifyMsgBox = Default])
; Parameters ....: $bNotifyMsgBox             - [optional] a boolean value. Default is Default.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_MiscProperty_NotifyToMsgBox($bNotifyMsgBox = Default)
	Local Static $bNotifyMsgBox_Static = False

	If $bNotifyMsgBox = Default Then
		Return $bNotifyMsgBox_Static
	ElseIf IsBool($bNotifyMsgBox) Then
		$bNotifyMsgBox_Static = $bNotifyMsgBox
		Return $bNotifyMsgBox_Static
	Else
		$bNotifyMsgBox_Static = False
		Return $bNotifyMsgBox_Static
	EndIf

	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $bNotifyMsgBox_Static)

EndFunc   ;==>_XML_MiscProperty_NotifyToMsgBox

; #FUNCTION# ===================================================================
; Name ..........: _XML_MiscProperty_UDFVersion
; Description ...: Returns UDF version number
; Syntax.........: _XML_MiscProperty_UDFVersion()
; Parameters ....: None
; Return values .: The UDF version number
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_MiscProperty_UDFVersion()
	Return "1.1.1.02"
EndFunc   ;==>_XML_MiscProperty_UDFVersion
#EndRegion XMLWrapperEx.au3 - Functions - Misc

#Region XMLWrapperEx.au3 - Functions - Arrays

; #INTERNAL_USE_ONLY#==========================================================
; Name ..........: _XML_Array_AddName
; Description ...: Adds an item to an array.
; Syntax.........: _XML_Array_AddName(ByRef $avArray, $sValue)
; Parameters ....: $avArray       - The array to modify.
;                  $sValue        - The value to add to the array.
; Return values .: Success        $XMLWRAPPER_RESULT_SUCCESS and value added to array.
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........:
; Modified ......: mLipok, guinness
; Remarks .......: Local version of _ArrayAdd to remove dependency on Array.au3
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XML_Array_AddName(ByRef $avArray, $sValue)
	Local $iUBound = UBound($avArray)
	If $iUBound Then ; IsArray() only tells you if it's an array data structure and not if elements are in the array.
		; Cache function call results, as function calls are expensive compared to variable lookups.
		ReDim $avArray[$iUBound + 1]
		$avArray[$iUBound - 1] = $sValue
		Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)
	EndIf

	; Else is not required, as this was always happen as a last resort.
	Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $XMLWRAPPER_RESULT_FAILURE)
EndFunc   ;==>_XML_Array_AddName

; @WIP
; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_Array_GetNodesProperties
; Description ...: Get IXMLDOMNode Members - properties, and put the result to array
; Syntax ........: _XML_Array_GetNodesProperties(Byref $oNodeColl)
; Parameters ....: $oNodeColl           - [in/out] an object.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: TODO @error and description
; Related .......:
; Link ..........: https://msdn.microsoft.com/en-us/library/ms761386(v=vs.85).aspx
; Example .......: yes
; ===============================================================================================================================
Func _XML_Array_GetNodesProperties(ByRef $oNodeColl)
	Local Enum _
			$eNodeList_nodeName, _
			$eNodeList_nodeTypeString, _
			$eNodeList_nodeValue, _
			$eNodeList_text, _
			$eNodeList_dataType, _
			$eNodeList_xml, _
			$eNodeList_attributes, _
			$eNodeList_Max

	Local $avArray[1][$eNodeList_Max]
	$avArray[0][$eNodeList_nodeName] = 'nodeName'
	$avArray[0][$eNodeList_nodeTypeString] = 'nodeTypeString'
	$avArray[0][$eNodeList_nodeValue] = 'nodeValue'
	$avArray[0][$eNodeList_text] = 'text'
	$avArray[0][$eNodeList_dataType] = 'dataType'
	$avArray[0][$eNodeList_xml] = 'xml'
	$avArray[0][$eNodeList_attributes] = 'attributes'
	Local $iUBound = 0

	For $oNodeEnum In $oNodeColl
		$iUBound = UBound($avArray)
		ReDim $avArray[$iUBound + 1][$eNodeList_Max]
		$avArray[$iUBound][$eNodeList_nodeName] = $oNodeEnum.nodeName
		$avArray[$iUBound][$eNodeList_nodeTypeString] = $oNodeEnum.nodeTypeString
		$avArray[$iUBound][$eNodeList_nodeValue] = $oNodeEnum.nodeValue
		$avArray[$iUBound][$eNodeList_text] = $oNodeEnum.text
		$avArray[$iUBound][$eNodeList_dataType] = $oNodeEnum.dataType
		$avArray[$iUBound][$eNodeList_xml] = $oNodeEnum.xml

		; check if node have any attributes
		If IsObj($oNodeEnum.attributes) And $oNodeEnum.attributes.length = 0 Then
			$avArray[$iUBound][$eNodeList_attributes] = ''
		Else
			Local $sAttributes = ''
			For $oAttribute In $oNodeEnum.attributes
				$sAttributes = $oAttribute.name & '="' & $oAttribute.text & '" '
			Next
			$avArray[$iUBound][$eNodeList_attributes] = StringTrimRight($sAttributes, 1)
		EndIf
	Next

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $avArray)

EndFunc   ;==>_XML_Array_GetNodesProperties


; @WIP
; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_Array_GetAttributesProperties
; Description ...: Get IXMLDOMAttribute Members - properties, and put the result to array
; Syntax ........: _XML_Array_GetAttributesProperties(Byref $oAttributesColl)
; Parameters ....: $oAttributesColl           - [in/out] an object.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: TODO @error and description
; Related .......:
; Link ..........: https://msdn.microsoft.com/en-us/library/ms767677(v=vs.85).aspx
; Example .......: Yes
; ===============================================================================================================================
Func _XML_Array_GetAttributesProperties(ByRef $oAttributesColl)
	Local Enum _
			$eAttributeList_AttributeName, _
			$eAttributeList_AttributeTypeString, _
			$eAttributeList_AttributeValue, _
			$eAttributeList_text, _
			$eAttributeList_dataType, _
			$eAttributeList_xml, _
			$eAttributeList_Max

	Local $avArray[1][$eAttributeList_Max]
	$avArray[0][$eAttributeList_AttributeName] = 'AttributeName'
	$avArray[0][$eAttributeList_AttributeTypeString] = 'AttributeTypeString'
	$avArray[0][$eAttributeList_AttributeValue] = 'AttributeValue'
	$avArray[0][$eAttributeList_text] = 'text'
	$avArray[0][$eAttributeList_dataType] = 'dataType'
	$avArray[0][$eAttributeList_xml] = 'xml'
	Local $iUBound = 0

	For $oAttributeEnum In $oAttributesColl
		$iUBound = UBound($avArray)
		ReDim $avArray[$iUBound + 1][$eAttributeList_Max]
		$avArray[$iUBound][$eAttributeList_AttributeName] = $oAttributeEnum.AttributeName
		$avArray[$iUBound][$eAttributeList_AttributeTypeString] = $oAttributeEnum.AttributeTypeString
		$avArray[$iUBound][$eAttributeList_AttributeValue] = $oAttributeEnum.AttributeValue
		$avArray[$iUBound][$eAttributeList_text] = $oAttributeEnum.text
		$avArray[$iUBound][$eAttributeList_dataType] = $oAttributeEnum.dataType
		$avArray[$iUBound][$eAttributeList_xml] = $oAttributeEnum.xml
	Next

	Return SetError($XMLWRAPPER_ERROR_OK, 0, $avArray)

EndFunc   ;==>_XML_Array_GetAttributesProperties

#EndRegion XMLWrapperEx.au3 - Functions - Arrays

#Region XMLWrapperEx.au3 - Functions - XML DOM Event Handler

Func __XML_DOM_EVENT_ondataavailable()
;~ ondataavailable Event
;~ https://msdn.microsoft.com/en-us/library/ms754530(v=vs.85).aspx
	Local $oXmlDoc = @COM_EventObj
	#forceref $oXmlDoc
	If _XML_MiscProperty_Notify() Then
		Local $sMessage = '__XML_DOM_EVENT_ fired "ondataavailable" from: XMLWrapperEx.au3: '
		__XML_Misc_MsgBoxNotifier($sMessage, '__XML_DOM_EVENT_   HANDLER')
	EndIf
EndFunc   ;==>__XML_DOM_EVENT_ondataavailable

Func __XML_DOM_EVENT_onreadystatechange()
;~ onreadystatechange Event
;~ https://msdn.microsoft.com/en-us/library/ms759186(v=vs.85).aspx
	Local $oXmlDoc = @COM_EventObj
	#forceref $oXmlDoc
	If _XML_MiscProperty_Notify() Then
		Local $sMessage = '__XML_DOM_EVENT_ fired "onreadystatechange" from: XMLWrapperEx.au3: ReadyState = ' & $oXmlDoc.ReadyState & @CRLF
		__XML_Misc_MsgBoxNotifier($sMessage, '__XML_DOM_EVENT_   HANDLER')
	EndIf

EndFunc   ;==>__XML_DOM_EVENT_onreadystatechange

Func __XML_DOM_EVENT_ontransformnode($oNodeCode_XSL, $oNodeData_XML, $bBool)
	#forceref $oNodeCode_XSL, $oNodeData_XML, $bBool
;~ ontransformnode Event
;~ https://msdn.microsoft.com/en-us/library/ms767521(v=vs.85).aspx
	Local $oXmlDoc = @COM_EventObj
	#forceref $oXmlDoc
	If _XML_MiscProperty_Notify() Then
		Local $sMessage = '__XML_DOM_EVENT_ fired "ontransformnode" from: XMLWrapperEx.au3: '
		__XML_Misc_MsgBoxNotifier($sMessage, '__XML_DOM_EVENT_   HANDLER')
	EndIf

EndFunc   ;==>__XML_DOM_EVENT_ontransformnode

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_UseEventHandler
; Description ...: XML DOM Events handler
; Syntax ........: _XML_UseEventHandler(Byref $oXML)
; Parameters ....: $oXML                - [in/out] an object.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: https://msdn.microsoft.com/en-us/library/ms764697(v=vs.85).aspx
; Example .......: No
; ===============================================================================================================================
Func _XML_UseEventHandler(ByRef $oXML)
	If _XML_MiscProperty_EventHandling() Then
		$__g_oXMLDOM_EventsHandler = ObjEvent($oXML, "__XML_DOM_EVENT_")
	Else
		$__g_oXMLDOM_EventsHandler = ''
	EndIf
EndFunc   ;==>_XML_UseEventHandler
#EndRegion XMLWrapperEx.au3 - Functions - XML DOM Event Handler

#Region XMLWrapperEx.au3 - Functions - Error Handling

; #INTERNAL_USE_ONLY#==========================================================
; Name ..........: __XML_ComErrorHandler_InternalFunction
; Description ...: A COM error handling routine.
; Syntax.........: __XML_ComErrorHandler_InternalFunction(_XML_MiscProperty_Notify() = "")
; Parameters ....: $oXML_COM_ErrorHandlerObj
; Return values .: None
; Author ........: ??
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func __XML_ComErrorHandler_InternalFunction(ByRef $oXML_COM_ErrorHandlerObj)
	Local $sMessage = _
			"$oXML_COM_ErrorHandlerObj.description is:    " & @TAB & $oXML_COM_ErrorHandlerObj.description & @CRLF & _
			"$oXML_COM_ErrorHandlerObj.windescription:    " & @TAB & $oXML_COM_ErrorHandlerObj.windescription & @CRLF & _
			"$oXML_COM_ErrorHandlerObj.number is:         " & @TAB & Hex($oXML_COM_ErrorHandlerObj.number, 8) & @CRLF & _
			"$oXML_COM_ErrorHandlerObj.lastdllerror is:   " & @TAB & $oXML_COM_ErrorHandlerObj.lastdllerror & @CRLF & _
			"$oXML_COM_ErrorHandlerObj.scriptline is:     " & @TAB & $oXML_COM_ErrorHandlerObj.scriptline & @CRLF & _
			"$oXML_COM_ErrorHandlerObj.source is:         " & @TAB & $oXML_COM_ErrorHandlerObj.source & @CRLF & _
			"$oXML_COM_ErrorHandlerObj.helpfile is:       " & @TAB & $oXML_COM_ErrorHandlerObj.helpfile & @CRLF & _
			"$oXML_COM_ErrorHandlerObj.helpcontext is:    " & @TAB & $oXML_COM_ErrorHandlerObj.helpcontext & @CRLF & _
			""
	If _XML_MiscProperty_Notify() Then
		__XML_Misc_MsgBoxNotifier($sMessage, 'COM Error with XMLWrapperEx.au3')
	EndIf

EndFunc   ;==>__XML_ComErrorHandler_InternalFunction

; #FUNCTION# ===================================================================
; Name ..........: __XML_ComErrorHandler_MainFunction
; Description ...: COM Error.
; Syntax.........: __XML_ComErrorHandler_MainFunction()
; Parameters ....: None
; Return values .: None
; Author ........: SvenP 's error handler
; Modified ......: mLipok
; Remarks .......: From the forum this came
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func __XML_ComErrorHandler_MainFunction($oError)
	__XML_ComErrorHandler_InternalFunction($oError)

	; Run also UserFunction defined by _XML_ComErrorHandler_UserFunctionName()
	Local $fnFunction = _XML_ComErrorHandler_UserFunction()
	If IsFunc($fnFunction) Then $fnFunction($oError)
EndFunc   ;==>__XML_ComErrorHandler_MainFunction

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_ComErrorHandler_UseInternalAsUser
; Description ...: TODO
; Syntax ........: _XML_ComErrorHandler_UseInternalAsUser(Byref $oTEST_local)
; Parameters ....: $oTEST_local         - [in/out] an object.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_ComErrorHandler_UseInternalAsUser(ByRef $oTEST_local)
	$oTEST_local = ObjEvent("AutoIt.Error", __XML_ComErrorHandler_InternalFunction)
EndFunc   ;==>_XML_ComErrorHandler_UseInternalAsUser

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_ComErrorHandler_UserFunctionName
; Description ...: Set a User function Wrapper to move the Fired Error event outside UDF
; Syntax ........: _XML_ComErrorHandler_UserFunction([$fnUserFunction = Default])
; Parameters ....: $fnUserFunction- [optional] a floating point value. Default is Default.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: Description TODO
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_ComErrorHandler_UserFunction($fnUserFunction = Default)
	Local Static $fnUserFunction_Static = ''
	If $fnUserFunction = Default Then Return $fnUserFunction_Static

	If Not IsFunc($fnUserFunction) Then
		$fnUserFunction_Static = ''
		Return SetError($XMLWRAPPER_ERROR_GENERAL, 0, $fnUserFunction_Static)
	EndIf

	$fnUserFunction_Static = $fnUserFunction
	Return $fnUserFunction_Static

EndFunc   ;==>_XML_ComErrorHandler_UserFunction

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_ErrorParser_GetDescription
; Description ...: Parse Error to Console
; Syntax ........: _XML_ErrorParser_GetDescription(Byref $oXmlDoc)
; Parameters ....: $oXmlDoc              - [in/out] an object.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: https://msdn.microsoft.com/en-us/library/ms767720(v=vs.85).aspx , https://msdn.microsoft.com/en-us/library/ms757019(v=vs.85).aspx
; Example .......: No
; ===============================================================================================================================
Func _XML_ErrorParser_GetDescription(ByRef $oXmlDoc)
	Local $sParseError_FullDescription = ''
	If IsObj($oXmlDoc) And $oXmlDoc.parseError.errorCode <> 0 Then
		$sParseError_FullDescription &= 'IXMLDOMParseError errorCode = ' & $oXmlDoc.parseError.errorCode & @CRLF ; Contains the error code of the last parse error.
		$sParseError_FullDescription &= 'IXMLDOMParseError filepos = ' & $oXmlDoc.parseError.filepos & @CRLF ; Contains the absolute file position where the error occurred.
		$sParseError_FullDescription &= 'IXMLDOMParseError line = ' & $oXmlDoc.parseError.line & @CRLF ; Specifies the line number that contains the error.
		$sParseError_FullDescription &= 'IXMLDOMParseError linepos = ' & $oXmlDoc.parseError.linepos & @CRLF ; Contains the character position within the line where the error occurred.
		$sParseError_FullDescription &= 'IXMLDOMParseError reason = ' & $oXmlDoc.parseError.reason & @CRLF ; Describes the reason for the error.
		$sParseError_FullDescription &= 'IXMLDOMParseError srcText = ' & $oXmlDoc.parseError.srcText & @CRLF ; Returns the full text of the line containing the error.
		$sParseError_FullDescription &= 'IXMLDOMParseError url = ' & $oXmlDoc.parseError.url & @CRLF ; Contains the URL of the XML document containing the last error.
	EndIf
	Return $sParseError_FullDescription
EndFunc   ;==>_XML_ErrorParser_GetDescription
#EndRegion XMLWrapperEx.au3 - Functions - Error Handling

#Region XMLWrapperEx.au3 - Functions - Work in progress

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Name ..........: __XML_IsValidObject
; Description ...: Chceck if Object is valid Msxml2.DOMDocument.xxxx Object
; Syntax ........: __XML_IsValidObject(Byref $oXML)
; Parameters ....: $oXML                - [in/out] an object.
; Return values .: Success             - $XMLWRAPPER_RESULT_SUCCESS
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func __XML_IsValidObject(ByRef $oXML)
	If Not IsObj($oXML) Then
		Return SetError($XMLWRAPPER_ERROR_ISNOTOBJECT, 0, $XMLWRAPPER_RESULT_FAILURE)
	ElseIf StringLeft(ObjName($oXML, $OBJ_NAME), StringLen('DOMDocument')) <> 'DOMDocument' Then
		Return SetError($XMLWRAPPER_ERROR_ISNOTVALIDOBJECT, 0, $XMLWRAPPER_RESULT_FAILURE)
	Else
		Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)
	EndIf
EndFunc   ;==>__XML_IsValidObject

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_Tidy
; Description ...: TODO
; Syntax ........: _XML_Tidy(Byref $oXML[, $sEncoding = "ISO-8859-1"])
; Parameters ....: $oXML                - [in/out] an object.
;                  $sEncoding           - [optional] a string value. Default is Default.
; Return values .: Success             - 1 and set @error = 0
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......: _XML_MiscProperty_Encoding
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_Tidy(ByRef $oXML, $sEncoding = Default)
	Local $sXML_Return = ''

	If $sEncoding = Default Then $sEncoding = _XML_MiscProperty_Encoding()

	Local $oReader = ObjCreate("MSXML2.SAXXMLReader")
	Local $oWriter = ObjCreate("MSXML2.MXXMLWriter")
	Local $oStream = ObjCreate("ADODB.STREAM")

	With $oStream
		.Open
		.Charset = $sEncoding

		With $oWriter
			.indent = True
			.encoding = $sEncoding
			.output = $oStream
		EndWith

		With $oReader
			.contentHandler = $oWriter
			.errorHandler = $oWriter
			.Parse($oXML)
		EndWith

		.Position = 0
		$sXML_Return = .ReadText($ADOENUM_adReadAll)

	EndWith

	Local $iSize = $oStream.size

	; CleanUp
	$oStream = Null
	$oReader = Null
	$oWriter = Null

	Return SetError($XMLWRAPPER_ERROR_OK, $iSize, $sXML_Return) ; TODO Description for @error and @extended

EndFunc   ;==>_XML_Tidy

; #FUNCTION# ====================================================================================================================
; Name ..........: _XML_TransformNode
; Description ...: TODO
; Syntax ........: _XML_TransformNode($sXML_FileFullPath, $sXSL_FileFullPath, $sHTML_FileFullPath[, $iEncoding = $FO_UTF8_NOBOM])
; Parameters ....: $sXML_FileFullPath   - a string value.
;                  $sXSL_FileFullPath   - a string value.
;                  $sHTML_FileFullPath  - a string value.
;                  $iEncoding           - [optional] an integer value. Default is $FO_UTF8_NOBOM.
; Return values .: Success             - 1 and set @error = 0
;                  Failure             - $XMLWRAPPER_RESULT_FAILURE and sets the @error flag to non-zero (look in #Region XMLWrapperEx.au3 - @ERROR Enums)
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _XML_TransformNode($sXML_FileFullPath, $sXSL_FileFullPath, $sHTML_FileFullPath, $iEncoding = $FO_UTF8_NOBOM)
	Local $oXML_COM_ErrorHandler = ObjEvent("AutoIt.Error", "__XML_ComErrorHandler_MainFunction")
	#forceref $oXML_COM_ErrorHandler

	; TODO file Checking , return values
	Local $oXSL_Document = ObjCreate("Microsoft.XMLDOM")
	; TODO Check following line
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	Local $oXmlDoc = ObjCreate("Microsoft.XMLDOM")
	; TODO Check following line
	If @error Then Return SetError(@error, @extended, $XMLWRAPPER_RESULT_FAILURE)

	_XML_UseEventHandler($oXmlDoc)

	$oXSL_Document.Async = False
	$oXSL_Document.Load($sXSL_FileFullPath)
	If $oXSL_Document.parseError.errorCode Then
		Return SetError($XMLWRAPPER_ERROR_PARSE_XSL, $oXSL_Document.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	$oXmlDoc.Async = False
	$oXmlDoc.Load($sXML_FileFullPath)
	If $oXmlDoc.parseError.errorCode Then
		Return SetError($XMLWRAPPER_ERROR_PARSE, $oXmlDoc.parseError.errorCode, $XMLWRAPPER_RESULT_FAILURE)
	EndIf

	Local $sHTML = $oXmlDoc.transformNode($oXSL_Document)

	Local $hFile = FileOpen($sHTML_FileFullPath, $FO_OVERWRITE + $iEncoding)
	FileWrite($hFile, $sHTML)
	FileClose($hFile)
	Return SetError($XMLWRAPPER_ERROR_OK, 0, $XMLWRAPPER_RESULT_SUCCESS)

EndFunc   ;==>_XML_TransformNode
; #INTERNAL_USE_ONLY#==========================================================
; Name ..........: _XSL_GetDefaultStyleSheet
; Description ...: Internal function, returns the default indenting style sheet.
; Syntax.........: _XSL_GetDefaultStyleSheet()
; Parameters ....:
; Return values .: Success        - The default stylesheet.
;                  Failure        - Nothing.
; Author ........: Hew Wolff - Art & Logic, Inc.
; Modified ......: mLipok
; Remarks .......: Posted all over the web.
; Related .......:
; Link ..........;
; Example .......; [yes/no]
; ==============================================================================
Func _XSL_GetDefaultStyleSheet()
	#CS
		Here was example from:
		http://www.xml.com/lpt/a/1681
		But it is: Copyright © 1998-2006 O'Reilly Media, Inc.

		TODO: Removal of _XSL_GetDefaultStyleSheet() from this UDF.
	#CE
	Return ''
EndFunc   ;==>_XSL_GetDefaultStyleSheet
#EndRegion XMLWrapperEx.au3 - Functions - Work in progress

#Region XMLWrapperEx.au3 - Help, Documentation, Manuals
#CS
	A Beginner's Guide to the XML DOM
	https://msdn.microsoft.com/en-us/library/aa468547.aspx

	DOM Reference
	https://msdn.microsoft.com/en-us/library/ms764730(v=vs.85).aspx

	XML DOM Properties
	https://msdn.microsoft.com/en-us/library/ms763798(v=vs.85).aspx

	XML DOM Methods
	https://msdn.microsoft.com/en-us/library/ms757828(v=vs.85).aspx

	XML Glossary
	https://msdn.microsoft.com/en-us/library/ms256452(v=vs.85).aspx

	MSXML API History
	https://msdn.microsoft.com/en-us/library/ms762314(v=vs.85).aspx

	XML Standards Reference
	https://msdn.microsoft.com/en-us/library/ms256177(v=vs.85).aspx

	XSLT Reference
	https://msdn.microsoft.com/en-us/library/ms256069(v=vs.85).aspx

	XPath Reference
	https://msdn.microsoft.com/en-us/library/ms256115(v=vs.85).aspx

	XPath Syntax
	https://msdn.microsoft.com/en-us/library/ms256471(v=vs.85).aspx

	XPath Examples
	https://msdn.microsoft.com/en-us/library/ms256086(v=vs.110).aspx

	Location Path Examples
	https://msdn.microsoft.com/en-us/library/ms256236(v=vs.110).aspx

	Microsoft XML DOM output has no CR/LF
	http://www.experts-exchange.com/Web_Development/Web_Languages-Standards/Q_20135543.html

	Formatting of XML file
	http://www.visualbasicscript.com/Formatting-of-XML-file-m77414.aspx

	Stream Object (ADO)
	https://msdn.microsoft.com/en-us/library/windows/desktop/ms675032(v=vs.85).aspx

	TODO:
	IXMLDOMAttribute Members  ($oAttribute)
	https://msdn.microsoft.com/en-us/library/ms767677(v=vs.85).aspx
#CE
#EndRegion XMLWrapperEx.au3 - Help, Documentation, Manuals

#Region XMLWrapperEx.au3 - TOOLs

#CS ON LINE XPath Tools
	http://www.xpathtester.com/xpath
	http://codebeautify.org/Xpath-Tester
	http://xpath.online-toolz.com/tools/xpath-editor.php
	http://www.whitebeam.org/library/guide/TechNotes/xpathtestbed.rhtm
	http://www.qutoric.com/xslt/analyser/xpathtool.html
	https://addons.mozilla.org/en-US/firefox/addon/xpather/
	http://www.xmlme.com/XpathTool.aspx
#CE

#CS OFF LINE XPath Tools
	http://qutoric.com/xmlquire/
	https://xpathvisualizer.codeplex.com/
#CE

#EndRegion XMLWrapperEx.au3 - TOOLs

#Region XMLWrapperEx.au3 - TODOs
;~ .parseError.errorCode --- as @extended
;~ .parseError.errorCode --- Wrapper --- get Description
#EndRegion XMLWrapperEx.au3 - TODOs

Func _XML_MiscProperty_StaticCOMErrorHandler(ByRef $oCOMErrorHandler)
	Local Static $oCOMErrorHandler_Static = $oCOMErrorHandler

	Return $oCOMErrorHandler_Static

EndFunc   ;==>_XML_MiscProperty_StaticCOMErrorHandler
